$(document).ready(function(){
	//用ESC关闭ajax窗口
	$(($.support.leadingWhitespace==false)?document:window).keydown(function(e){$.kc_keydown(e.keyCode)});
	//提取广告位
	var href=location.href;
	var re=/[A-Z]\d+$/;
	var id=href.match(re);
	if(id!=null){
		$('#ad_'+id)
		.html('广告位['+id+']')
		.css({
			'background':'#F00',
			'color':'#FFF',
			'font-weight':'bold',
			'font-size':'16px'
		});
	}
});

(function ($){
	//键盘响应
	$.kc_keydown=function(Key){
		switch(Key){
			case 27:
			$.kc_close();
			break;
		}
	}
	//获得当前页地址
	$.kc_href=function(){
		var s=location.href;
		var num;
		num=s.indexOf('#');
		if(num>0) s=s.substring(0,num);
		num=s.indexOf('?');
		if(num>0) s=s.substring(0,num);
		return s;
	}

	$.kc_ajax=function(r){
		//跳转
		if(r.GOTO!=undefined){
			location.href=r.GOTO;
			return false;
		}

		var url = r.URL == undefined ? $.kc_href() : r.URL;//传递页定义
		var cmd = r.CMD == undefined ? '' : r.CMD;//定义传递函数
		//显示LOADING方式,指定值则在对应的对象中显示，默认(0)浮动显示,1关闭显示
		var load = r.LOAD == undefined ? 0 : r.LOAD;
		var form = r.FORM == undefined ? '#kc_form' : '#'+r.FORM;//读取值的表单域
		var ids = r.IDS;//单独指定的提交值
		var isc = r.ISCONFIRM;//是否进行验证
		var postdata=r;
		postdata['AJAX']=1;//告诉服务器是AJAX提交的
		postdata['HTTP_REFERER']= r['HTTP_REFERER']==undefined ? location.href :r['HTTP_REFERER'];//当前页地址
		postdata['URL']= url;
		var s_main;

		if (isc==undefined) {		
			if (ids!=undefined) {
				var idss=ids.split(',');
				$.each(idss,function(i,n){
					postdata[n]=$('#'+n).val();
				});
			}
			$(form+' input:text,'+form+' input:password,'+form+' input[type="hidden"],'+form+' textarea').each(function(i,n){
				if(n.name) postdata[n.name]=$(n).val();
			});
			$(form+' input:radio:checked').each(function(i,n){
				if(n.name) postdata[n.name]=$(n).val();
			});
			var fields=$(form+' select').serializeArray();
			$.each(fields,function(i,n){
				if(n.name) postdata[n.name] = postdata[n.name]==undefined ? n.value : postdata[n.name]+','+n.value;
			});
			$(form+' :checkbox:checked').each(function(i,n){
				if(n.name) postdata[n.name] = postdata[n.name]==undefined ? n.value : postdata[n.name]+','+n.value;
			});
			var t=cmd.match(/(delete|clear|close|logout)/);
			if(t){
				s_main='<table>';
				s_main+='<tr><th><img src="/images/confirm_'+t[0]+'.gif"/></th><td>'+kc_lang['confirm'][t[0]]+'</td></tr>';
				s_main+='</table>';					
				var rr=postdata;
				rr['ISCONFIRM']=1;
				var s='';
				for(key in rr){
					s+=','+key+":'"+(rr[key].toString()).replace(/(\\|\')/g,'\\$1')+"'";
				}
				s='{'+s.substring(1)+'}';
				var s_but='<button onclick="$.kc_ajax('+s+');return false;">'+kc_lang.enter+'</button>';
				var s_r={TITLE:kc_lang['confirm']['title'],MAIN:s_main,BUTTON:s_but,WIDTH:400,HEIGHT:180};
				window.parent.$.kc_ajax_show(s_r);
				return;
			}
		}

		if (load==0) {//默认(0)浮动显示,1关闭显示
			if ($('#kc_loading').length==0) {
				$('body').append('<div id="kc_loading">'+kc_lang['loading']+'</div>')
			}
		}

		$.ajax({
			url:url,
			type:'POST',
			data:postdata,
			dataType:'json',
			timeout:120000,
			error:function(){
				$.kc_close();
				s_main='<table>';
				s_main+='<tr><th><img src="/images/confirm_error.gif"/></th><td>'+kc_lang['timeout']+'</td></tr>';
				s_main+='</table>';
				window.parent.$.kc_ajax_show({TITLE:'Error!',MAIN:s_main,BUTTON:'<button onclick="$.kc_close();return false;">'+kc_lang['enter']+'</button>',WIDTH:320,HEIGHT:180});
			},
			success: function(back){
				//提交操作的时候动作
				$('#kc_loading').remove();
				$('.kc_error').removeClass('kc_error');

				var id=back.ID;
				if(id=='kc_ajax'){
					window.parent.$.kc_ajax_show(back);
				}else{
					var main=back.MAIN;
					var js=back.JS;
					if(main!=undefined){
						$('#'+id).html(main);
					}
					if(js!=undefined){
						eval(js);
					}
				}
			}
		});

	}
	//构造ajax交互窗口
	$.kc_ajax_show=function(r){
		var title=r.TITLE;
		var main=r.MAIN;
		var but=r.BUTTON;
		var width=r.WIDTH;
		var height=r.HEIGHT;
		var js=r.JS;
		// 赋值并显示
		if(title!=undefined||main!=undefined){

			var w=$(window).width();
			var h=$(window).height();
			var isOpera = /opera/.test(navigator.userAgent.toLowerCase());
			if(isOpera){//opera下$(window).height 并不是可是区域大小,不知道是不是jQuery的bug?
				h=document.documentElement.clientHeight;
			}

			if ($('#kc_ajax').length==0) {
				$(document.body).append('<div id="kc_ajax"></div>');
			}
			var str='<div class="kc_ajaxbg"></div>';
			str+='<div class="kc_ajaxbox" id="kc_ajaxbox">';
			str+='<div id="kc_ajaxheader"><strong></strong><a href="javascript:;" onclick="$.kc_close();return false;">x</a></div>';
			str+='<form id="kc_ajaxform">';
			str+='<div id="kc_ajaxcontent"></div>';
			str+='<div id="kc_ajaxfooter"></div>';
			str+='</form>';
			str+='</div>';

			$('#kc_ajax').html(str).show();
			$('#kc_ajaxbox').css({
				'margin-top':($(window).scrollTop()-height/2),
				'width':width,
				'margin-left':(-1)*(width/2)
			});
			
			$(window).resize(function(){
				w=$(window).width();
				$('#kc_ajaxbox').css({
					'margin-top':($(window).scrollTop()-height/2),
					'width':width,
					'margin-left':(-1)*(width/2)
				});

			}).scroll(function(){//Opera下隐藏滚动条的情况下还能上下拖动..
				w=$(window).width();
				$('#kc_ajaxbox').css({
					'margin-top':($(window).scrollTop()-height/2),
					'width':width,
					'margin-left':(-1)*(width/2)
				});
			});

			$('#kc_ajaxheader strong').html(title);
			$('#kc_ajaxcontent').html(main);
			$('#kc_ajaxfooter').html(''+but+'<button onclick="$.kc_close();return false;" class="kc_ajaxcancel">'+kc_lang.cancel+'</button>');
			$('#kc_ajaxform').submit(function(){
				return false;
			});
		}

		if(js!=undefined){
			eval(js);
		}
	}
	//返回ajax弹窗按钮
	$.kc_button=function(tit,r){
		var s_main,key,s='';
		for(key in r){
			s+=','+key+":'"+(r[key].toString()).replace(/(\\|\')/g,'\\$1')+"'";
		}
		s='{'+s.substring(1)+'}';
		s_main='<button onclick="$.kc_ajax('+s+');return false;">'+tit+'</button>';
		return s_main;
	}
	//关闭弹窗
	$.kc_close=function(){
		$('#kc_ajax').remove();
		$('#kc_loading').remove();
	}
	//checkbox框
	$.kc_list=function(id,gray){
		var s;
		s = gray==1
		? '<input disabled="true" name="list_disabled" id="list_'+id+'" type="checkbox" value="'+id+'"/>'
		: '<input onclick="$.kc_list_click(this)" name="list" id="list_'+id+'" type="checkbox" value="'+id+'"/>';
		return s;
	}
	//控制checkbox框 全部选择
	$.kc_list_select=function(obj,name){
		if(obj.checked){
			$('input:checkbox[name="'+name+'"]').prop('checked',true);
		}else{
			$('input:checkbox[name="'+name+'"]').prop('checked',false);
		}
	}
	$.kc_nbsp=function(n){
		var i,s='';
		for (i = 0; i < n; i++) {
			s+='<img src="images/nbsp.gif" class="nbsp"/>';
		}
		return s;
	}
	//创建上传按钮
	//@param strong menu(ID) 要渲染的按钮的ID,不带#
	//@param strong name(ID) 返回赋值的对象,不带#
	//@param strong action 上传地址,如：{DIR}user/up_image.php
	//@param strong act 数据处理方式|undefined:赋值给name对象;image:name指定的编辑器里插入img代码;file:编辑器里插入a连接对象;function:直接执行
	//@returns false
	$.kc_upload=function(menu,name,action,act) {
		new AjaxUpload('#'+menu, {
			action: action,
			name:'filedata',
			onComplete : function(file,obj,js){
				if(obj!='' && obj!=undefined && obj!=null){
					var r=eval('('+obj+')');
					if(r['err']!=''){
						alert(r['err']);
						return false;
					}
				}				
				if(act===undefined){
					$('#'+name).val(r['msg']['id']);
				}else if(act==='image'){
					editors[name].pasteHTML('<p style="text-align:center"><img src="'+r['msg']['url'].substring(1)+'" alt=""/></p>');
				}else if(act==='file'){
					editors[name].pasteHTML('<p style="text-align:left"><a href="'+r['msg']['url'].substring(1)+'" target="_blank">'+r['msg']['localname']+'</a></p>');
				}else if($.isFunction(act)){
					$('#'+name).val(r['msg']['id']);
					act(r['msg']['id']);
				}else if(act!==''){
					window.location=act+'&name='+name+'&id='+r['msg']['id'];
				}
				return r['msg']['id'];
			}
		});
	}
	//文字统计
	$.kc_len=function(v){
		var len=0;   
		for(i=0;i<v.length;i++){
			len += v.charCodeAt(i) > 256 ? 2 : 1;
		}
		return len;
	}
	//读取Cookie,仿php的读取Cookie
	$.COOKIE=function(name){
		var sta=document.cookie.indexOf(name+"=");
		var len=sta+name.length+1;
		if((!sta)&&(name!=document.cookie.substring(0,name.length))){
			return null;
		}
		if(sta==-1) return null;
		var end=document.cookie.indexOf(';',len);
		if(end==-1) end=document.cookie.length;
		return unescape(document.cookie.substring(len,end));
	}
	//设置Cookie
	$.setCookie=function(name,value,expires,path,domain,secure){
		var today=new Date();
		today.setTime( today.getTime() );
		if ( expires ) {
		expires = expires * 1000 * 60 * 60 * 24;
		}
		var expires_date = new Date( today.getTime() + (expires) );
		document.cookie = name+'='+escape( value ) + ( ( expires ) ? ';expires='+expires_date.toGMTString() : '' ) +
		( ( path ) ? ';path=' + path : '' ) + ( ( domain ) ? ';domain=' + domain : '' ) + ( ( secure ) ? ';secure' : '' );
	}
	//设置表单内容值，数据由json转换而来
	$.kc_setvalue=function(formid,data){
		var arr;
		for(key in data){
			val=data[key];
			$(formid+' input[type="text"][name="'+key+'"]').val(val);
			$(formid+' input[type="hidden"][name="'+key+'"]').val(val);
			$(formid+' textarea[name="'+key+'"]').val(val);		
			$(formid+' input[type="radio"][name="'+key+'"][value="'+escape(val)+'"]').attr('checked','true');
			$(formid+' select[name="'+key+'"] option[value="'+escape(val)+'"]').attr('selected','true');		
			$(formid+' input[type="checkbox"][name="'+key+'"]').attr('checked', 'false');
			if(val!='' && val!=null){
				arr = val.split(',');
				for(k in arr){
					$(formid+' input[type="checkbox"][name="'+key+'"][value="'+escape(arr[k])+'"]').attr('checked','true');
				}
			}
		}
	}
	//设置样式表
	$.kc_setStyle=function(name,style){
		if(style!=undefined){
			var obj=$(name);			
			var setstyle = {
				'b':function(){setstyle.check(/font\-weight\:bold;/i,'font-weight:bold;')},
				'i':function(){setstyle.check(/font\-style\:inherit;/i,'font-style:inherit;')},
				'u':function(){setstyle.check(/text\-decoration\:underline;/i,'text-decoration:underline;')},
				'color':function(c){setstyle.check(/color\:([a-z]+|\#[a-zA-Z0-9]{3,6});/i,(c==''?'':'color:'+c+';'),true)},
				'check':function(m,text,is){
					var val=obj.val();
					if(val==''){
						obj.val(text);
					}else if(val.match(m)==null){
						obj.val(text+val);
					}else{
						if(is==true){
							obj.val(val.replace(m,text));
						}else{
							obj.val(val.replace(m,''));
						}
					}
				}
			};			
			setstyle[(style=='b'||style=='i'||style=='u')?style:'color'](style);
			return;
		}		
		s='<p class="kc_ajaxstyle">';
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"','b')\" style=\"font-weight:bold;\">加粗</a>";
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"','i')\" style=\"font-style:inherit;\">斜体</a>";
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"','u')\" style=\"text-decoration:underline;\">下划线</a>";
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"',\'red\');\" style=\"color:red;\">红</a>";
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"',\'orange\');\" style=\"color:orange;\">橘黄</a>";
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"',\'blue\');\" style=\"color:blue;\">蓝</a>";
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"',\'green\');\" style=\"color:green;\">绿</a>";
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"',\'purple\');\" style=\"color:purple;\">紫</a>";
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"',\'black\');\" style=\"color:black;\">黑</a>";
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"',\'gray\');\" style=\"color:gray;\">灰</a>";
		s+="<a href=\"javascript:;\" onclick=\"$.kc_setStyle('"+name+"',\'\');\">默认</a>";
		s+='</p>';
		$(name).before(s);
	}

})(jQuery);

function go(url){parent.location=url;}
function setCopy(s){try{clipboardData.setData('Text',s);alert('本页地址已成功复制在剪贴板内！')}catch(e){}}
//语言包
var kc_lang={
	'confirm' : {
		'title' : '确认操作',
		'delete' : '确定要删除?<br/>注意: 被删除内容可能永远无法恢复!',
		'clear' : '确定要清空?<br/>注意: 所有内容将被彻底删除!',
		'close' : '确定要关闭?',
		'logout' : '确定要退出登录?'
	},
	'close' : '关闭',
	'save' : '保存',
	'preview' : '预览',
	'enter' : '确定',
	'cancel' : '取消',
	'empty' : '返回值为空!',
	'timeout' : '页面执行超时或输出错误！',
	'loading' : '数据加载中...',
	'month_names': ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"],
	'short_month_names': ["一", "二", "三", "四", "五", "六", "七", "八", "九", "十", "十一", "十二"],
	'short_day_names': ["日","一", "二", "三", "四", "五", "六"]
}
//中途跳转提示
var unloadConfirm={
	'set':function(msg){
		window.onbeforeunload = function(event){
			event = event || window.event;
			event.returnValue = msg;
			return msg;
		}
	},
	'clear':function(){
		window.onbeforeunload = function(){};
	}
}
function htmlencode(text){
	if(text==undefined||text==null||text=='') return '';
	text = text.replace(/&/g, '&amp;') ;
	text = text.replace(/"/g, '"&quot;') ;
	text = text.replace(/'/g, '"&#039;') ;
	text = text.replace(/</g, '&lt;') ;
	text = text.replace(/>/g, '&gt;') ;
	text = text.replace(/\n/g,'<br/>');
	text = text.replace(/\t+/g,' ');
	return text;
}