<?php
define('CLOSETASK',true);// 读取远程数据的时候不能蹦出计划任务。
require '../global.php';

function _getBackUp(){
	if(empty($_GET['jsoncallback'])) exit('非法提交!');
	$jsoncallback=$_GET['jsoncallback'];
	$str=new str;
	$db=new db;
	$file=new file;
	if(empty($_GET['SIGN'])) exit($jsoncallback.'('.json_encode(array('error'=>'丢失密文，禁止解析!')).')');
	//验证权限
	$sign=$_GET['SIGN'];
	unset($_GET['SIGN'],$_GET['_'],$_GET['jsoncallback']);
	$arr=array();
	foreach($_GET as $key => $val){
		if($key!='CMD') $arr[$key]=$key.'='.urlencode($val);
	}
	ksort($arr);
	$param=implode('&',$arr);
	$sign1=md5($param.kc_config('system.salt'));
	if($sign!=$sign1) exit($jsoncallback.'('.json_encode(array('error'=>'审核失败,数据不一致!')).')');
	$_GET=array_map('base64_decode',$_GET);
	$filetype=trim($_GET['filetype']);
	$arr=array();
	$metinfodata = array();
	if(!empty($filetype)){
		$sqlfiles = glob(ROOT.'databack/sql/*');
		if(is_array($sqlfiles)){
			foreach($sqlfiles as $id=>$sqlfile){
				if (filetype($sqlfile) == 'dir') {
					$temps = glob($sqlfile.'/*.sql');
					if(empty($temps)){
						@rmdir($sqlfile);
						continue;
					}
					$info = array();
					if(is_array($temps)){
						$i=0;
						foreach($temps as $k=>$val){
							 preg_match("/([0-9]{8}_[0-9]{1})_([0-9]+)_[0-9a-zA-Z]+\.sql/i",basename($val),$num);
							 $info['filename'] = basename($val);
							 $info['filesize'] += round(filesize($val)/(1024*1024), 2);
							 $info['maketime'] = date('Y-m-d H:i:s', filemtime($val));
							 $info['pre'] = $num[1];
							 $info['typename']='数据库';
							 $info['type']='sql';
							 $i++;
						}
						$info['number'] = $i;
					}
					$metinfodata[]=$info;
				}
			}
		}
	}else{
		$sqlfiles = glob(ROOT.'databack/sql/*.zip');
		if(is_array($sqlfiles))
		{
			 $info = array();
			 foreach($sqlfiles as $id=>$sqlfile)
			 {
				 $info['filename'] = basename($sqlfile);
				 $info['filesize'] = round(filesize($sqlfile)/(1024*1024), 2);
				 $info['maketime'] = date('Y-m-d H:i:s', filemtime($sqlfile));
				 $info['typename']='数据库';
				 $info['type']='sql';
				 $metinfodata[]=$info;
			 }
		}
		$sqlfiles = glob(ROOT.'databack/upload/*.zip');
		if(is_array($sqlfiles))
		{
			$info = array();
			foreach($sqlfiles as $id=>$sqlfile)
			{
				 $info['filename'] = basename($sqlfile);
				 $info['filesize'] = round(filesize($sqlfile)/(1024*1024), 2);
				 $info['maketime'] = date('Y-m-d H:i:s', filemtime($sqlfile));
				 $info['typename']='上传文件夹';
				 $info['type']='upload';
				 $metinfodata[]=$info;
			}
		}
		$sqlfiles = glob(ROOT.'databack/web/*.zip');
		if(is_array($sqlfiles))
		{
			 $info = array();
			 foreach($sqlfiles as $id=>$sqlfile)
			 {
				 $info['filename'] = basename($sqlfile);
				 $info['filesize'] = round(filesize($sqlfile)/(1024*1024), 2);
				 $info['maketime'] = date('Y-m-d H:i:s', filemtime($sqlfile));
				 $info['typename']='整站压缩包';
				 $info['type']='web';
				 $metinfodata[]=$info;
			 }
		}
	}
	$metinfodata1 = array();
	foreach($metinfodata as $key=>$val){
		if($val['maketime']) $val['time']=strtotime($val['maketime']);
		$metinfodata1[]=$val;
	}
	$metinfodata=array_sort($metinfodata1,'time','desc');
	
	header('Content-Type: text/javascript; charset=utf-8');
	ini_set('display_errors',1);
	$arr['data'] = $metinfodata;
	echo $jsoncallback.'('.json_encode($arr).')';
	exit();
}

function array_sort($arr,$keys,$type='asc'){ 
	$keysvalue = $new_array = array();
	foreach ($arr as $k=>$v){
		$keysvalue[$k] = $v[$keys];
	}
	if($type == 'asc'){
		asort($keysvalue);
	}else{
		arsort($keysvalue);
	}
	reset($keysvalue);

	foreach ($keysvalue as $k1=>$v1){
		$new_array[] = $arr[$k1];
	}
	return $new_array; 
}
//上传数据库文件
function _uploadfile(){
	$go=empty($_GET['go'])?'up_setid':$_GET['go'];
	$s='<!DOCTYPE html>
	<html lang="zh-cn">
	<head>
		<meta charset="utf-8">
		<title>上传图片</title>
		<script charset="UTF-8" src="'.DIR.'user/js/jquery.js"></script>
		<script charset="UTF-8" src="'.DIR.'user/js/system.js"></script>
		<script charset="UTF-8" src="'.DIR.'user/js/ajaxupload.js"></script>
		<!--[if lt IE 9]>
		<script charset="UTF-8" src="'.DIR.'user/js/html5.js"></script>
		<![endif]-->
		<style type="text/css">html,body{padding:0;margin:0;}input{padding:0;margin:0;width:135px;height:30px;font-size:100px;cursor:pointer;}</style>
	</head>
	<body>
		<input id="up_sql" value="上传数据库文件" type="submit" onclick="return false;"/>
		<script type="text/javascript">$.kc_upload(\'up_sql\',\'up_sql\',\''.DIR.'user/manage_data.php?CMD=upsqlfile\',\''.SERV.'?_=data_download'.'\');</script>
	</body>
	</html>
	';
	exit($s);
}

function _upsqlfile(){
	$path='databack/sql/';
	if(!file_exists(ROOT.$path)){
		$file=new file;
		$file->md($path);
	}
	$inputname='filedata';//表单文件域name
	if (isset($_FILES[$inputname])) {
		$upfile=$_FILES[$inputname];
		if($upfile['error']==4){
			echo "{'err':'".jsonString('请选择要上传的文件')."','msg':''}";
			exit();
		}else{
			//有文件上传的时候判断并提示
			$upload_max_filesize=@ini_get('upload_max_filesize');
			$maxattachsize=return_bytes($upload_max_filesize);
			if($upfile['size']>$maxattachsize){
				echo "{'err':'".jsonString('请不要上传大小超过'.$upload_max_filesize.'的文件')."','msg':''}";
				exit();
			}
			$filename=$upfile['name'];//文件名
			$fext=strtolower(substr(strrchr($filename,'.'),1));
			//判断文件扩展名是否符合要求
			if(!in_array($fext,array('sql','zip'))){
				echo "{'err':'".jsonString('文件类型只能是sql,zip中的一种')."','msg':''}";
				exit();
			}
		}
		if($fext=='sql'){
			$newdirname=make_backup_name();
			$newfilename=$newdirname.'_1_'.met_rand(6);
			if(!file_exists(ROOT.$path.$newdirname)){
				$file=new file;
				$file->md($path.$newdirname);
			}
			move_uploaded_file($upfile['tmp_name'], ROOT.$path.$newdirname.'/'.$newfilename.'.'.$fext);
		}else{
			$newfilename=date('YmdHis',time()).'_1_'.met_rand(6);
			//保存文件
			move_uploaded_file($upfile['tmp_name'], ROOT.$path.$newfilename.'.'.$fext);
		}
		$err = '文件上传成功';
	}else{
		$err = '文件上传失败';
	}
	echo "{'err':'".jsonString($err)."','msg':''}";
	exit();
}
//备份数据库和文件
function _allfile(){
	set_time_limit(0);
	$webpath='databack/web';
	$sqlpath='databack/sql';
	$db=new db;
	if(!file_exists(ROOT.$webpath)){
		$file=new file;
		$file->md($webpath);
	}
	if(!file_exists(ROOT.$sqlpath)){
		$file=new file;
		$file->md($sqlpath);
	}
	$tablestx=isset($_POST['tablestx']) ? trim($_POST['tablestx']) : '';
	$fileid = isset($_POST['fileid']) ? intval($_POST['fileid']) : 1;
	$tables = array(); //备份队列
	if(!empty($tablestx)){
		$allidlist=explode('|',$tablestx);
		for($i=0;$i<count($allidlist)-1;$i++){
			$tables[]=$allidlist[$i];
		}
	}else{
		//首次提交的需要备份的表
		$all_tables = $db->get("show tables LIKE '". DB_PRE . "%'");
		foreach ($all_tables as $key => $table) {
			$tables[] = current($table);
		}
		if(!$tables) kc_tip('没有相关的数据表!','form');
		$tablestx='';
		foreach($tables as $key=>$val){
			$tablestx.=$val.'|';
		}
		$pre = make_backup_name();
		if(!file_exists(ROOT.$sqlpath.'/'.$pre)){
			$file=new file;
			$file->md($sqlpath.'/'.$pre);
		}
	}
	$vol_size = 2048; //分卷大小kb
	$pre = !empty($_POST['pre']) ? trim($_POST['pre']) : $pre; //数据库前缀
	$random =met_rand(6);	
    //开始备份	
	$sqldump = '';
	$startrow = 0;
	$tableid = isset($_POST['tableid']) ? $_POST['tableid'] - 1 : 0;
	$startfrom = isset($_POST['startfrom']) ? intval($_POST['startfrom']) : 0;
	$tablenumber = count($tables);
	for($i = $tableid; $i < $tablenumber && strlen($sqldump) < $vol_size * 1024; $i++){
		$temp = sql_dumptable($tables[$i], $startfrom, strlen($sqldump), $vol_size);
		$sqldump .= $temp['tabledump'];
		$startrow = $temp['startrow'];
		$startfrom = 0;
	}
	if(trim($sqldump)){
		$tableid = $i;
		$filename = $pre.'_'.$fileid.'_'.$random.'.sql';
		$zipname  = $pre.'_'.$fileid.'_'.$random;
		$fileid++;
		$bakfile = ROOT.$sqlpath.'/'.$pre.'/'.$filename;
		file_put_contents($bakfile, $sqldump);
		$zipurl = ROOT.$sqlpath.'/'.$zipname.'.zip';//生成的压缩包位置
		require(ROOT."user/library/pclzip.class.php");
		$zip = new PclZip($zipurl);
		$zip_list=$zip->create(ROOT.$sqlpath.'/'.$pre, PCLZIP_OPT_REMOVE_PATH, ROOT.$sqlpath);
		$js="\$.kc_ajax({URL:'".FULLURL."user/manage_data.php',CMD:'allfile',startfrom:'$startrow',vol_size:'$vol_size',tableid:'$tableid',fileid:'$fileid',pre:'$pre',tablestx:'$tablestx'});";
		kc_ajax(array('JS'=>$js));
	}else{
		$zipurl = ROOT.$webpath.'/web_'.date('YmdHis',time()).'.zip';//生成的压缩包位置
		$array = array(ROOT.'images', ROOT.'user', ROOT.'templates', ROOT.'upfiles', ROOT.'api', ROOT.'apps', ROOT.'install', ROOT.'global.php', ROOT.'index.php', ROOT.'config.php', ROOT.'admin.php', ROOT.$sqlpath.'/'.$pre);
		$zipfile= implode(',',$array);//要压缩的目录
		require(ROOT."user/library/pclzip.class.php");
		//实例化类库
		$zip = new PclZip($zipurl);
		$zip_list=$zip->create($zipfile,PCLZIP_OPT_REMOVE_PATH, ROOT);  
		kc_ajax(array('JS'=>"go('?_=data_download')"));
	}
}
//备份上传文件
function _uploadimg(){
	$u=new user;$u->auth_role('admin');
	$path='databack/upload';
	if(!file_exists(ROOT.$path)){
		$file=new file;
		$file->md($path);
	}
	$zipurl = ROOT.$path.'/uploadfile_'.date('YmdHis',time()).'.zip';//生成的压缩包位置
	$zipfile= ROOT.'images';//要压缩的目录
	require(ROOT."user/library/pclzip.class.php");
	//实例化类库
	$zip = new PclZip($zipurl);
	$zip_list=$zip->create($zipfile,PCLZIP_OPT_REMOVE_PATH, ROOT); 
	if ($zip_list == 0) {
		kc_tip('压缩文件出错！');
	}
	kc_ajax(array('JS'=>"go('{$_POST['HTTP_REFERER']}')"));
}
//备份数据库
function _allbase(){
	//$u=new user;$u->auth_role('admin');
	$vol_size = isset($_POST['vol_size']) ? intval($_POST['vol_size']) : 0; //分卷大小kb
    if($vol_size < 100) kc_tip('分卷大小不能小于100kb!','form');
	if($vol_size > 2048) kc_tip('分卷大小不能大于2048kb!','form');
	set_time_limit(0);
	$path='databack/sql';
	$db=new db;
	if(!file_exists(ROOT.$path)){
		$file=new file;
		$file->md(dirname($path));
	}
	$tablestx=isset($_POST['tablestx']) ? trim($_POST['tablestx']) : '';
	$fileid = isset($_POST['fileid']) ? intval($_POST['fileid']) : 1;
	$tables = array(); //备份队列
	if(!empty($tablestx)){
		$allidlist=explode('|',$tablestx);
		for($i=0;$i<count($allidlist)-1;$i++){
			$tables[]=$allidlist[$i];
		}
	}else{
		//首次提交的需要备份的表
		$all_tables = $db->get("show tables LIKE '". DB_PRE . "%'");
		foreach ($all_tables as $key => $table) {
			$alltables[] = current($table);
		}
		$backup_type=kc_post('backup_type',0,1);
		if(isset($backup_type) && $backup_type == 'backup_all')  $tables = $alltables;
		if(isset($backup_type) && $backup_type == 'backup_custom'){
			$tablelist = kc_post('tables');
			$tables=explode(',',$tablelist[0]);
		}
		if(!$tables) kc_tip('请选择数据表!','form');
		$tablestx='';
		foreach($tables as $key=>$val){
			$tablestx.=$val.'|';
		}
		$pre = make_backup_name();
		if(!file_exists(ROOT.$path.'/'.$pre)){
			$file=new file;
			$file->md($path.'/'.$pre);
		}
	}
	$pre = !empty($_POST['pre']) ? trim($_POST['pre']) : $pre; //数据库前缀
	
	$random =met_rand(6);
    //开始备份	
	$sqldump = '';
	$startrow = 0;
	$tableid = isset($_POST['tableid']) ? $_POST['tableid'] - 1 : 0;
	$startfrom = isset($_POST['startfrom']) ? intval($_POST['startfrom']) : 0;
	$tablenumber = count($tables);
	for($i = $tableid; $i < $tablenumber && strlen($sqldump) < $vol_size * 1024; $i++){
		$temp = sql_dumptable($tables[$i], $startfrom, strlen($sqldump), $vol_size);
		$sqldump .= $temp['tabledump'];
		$startrow = $temp['startrow'];
		$startfrom = 0;
	}
	if(trim($sqldump)){
		$tableid = $i;
		$filename = $pre.'_'.$fileid.'_'.$random.'.sql';
		$fileid++;
		$bakfile = ROOT.$path.'/'.$pre.'/'.$filename;
		file_put_contents($bakfile, $sqldump);
		$js="\$.kc_ajax({URL:'".FULLURL."user/manage_data.php',CMD:'allbase',startfrom:'$startrow',vol_size:'$vol_size',tableid:'$tableid',fileid:'$fileid',pre:'$pre',tablestx:'$tablestx'});";
		kc_ajax(array('JS'=>$js));
	}else{
		$zipname  = $pre;
		$zipurl = ROOT.$path.'/'.$zipname.'.zip';//生成的压缩包位置
		include_once(ROOT."user/library/pclzip.class.php");
		$zip = new PclZip($zipurl);
		$zip_list=$zip->create(ROOT.$path.'/'.$pre, PCLZIP_OPT_REMOVE_PATH, ROOT.$path);
		kc_ajax(array('JS'=>"go('?_=data_recovery')"));
	}
}
//导入数据库
function _sql_import(){
	set_time_limit(0);
	$path='databack/sql/';
	$db=new db;
	$pre = kc_post('pre',0,1); //数据库前缀
	$files = glob(ROOT.$path.$pre.'/*.sql');
	if(is_array($files)){
		foreach($files as $k=>$val){
			$sql = file_get_contents($val);
			sql_execute($sql,DB_PRE);
		}
	}
	kc_ajax(array('JS'=>"go('{$_POST['HTTP_REFERER']}')"));
}
//删除备份
function _delete(){
	$u=new user;$u->auth_role('admin');
	$pre=kc_post('pre',0);
	if(!empty($pre)){
		$sqlfiles = glob(ROOT.'databack/sql/'.$pre.'/*.sql');
		if(!empty($sqlfiles)){
			foreach($sqlfiles as $id=>$sqlfile){
				@unlink($sqlfile);
			}	
		}
		@rmdir(ROOT.'databack/sql/'.$pre);
	}else{
		$filenames=kc_post('filenames',0,1);
		$fileon=kc_post('fileon',0,1);
		@unlink(ROOT.'databack/'.$fileon.'/'.$filenames);
	}
	kc_ajax(array('JS'=>"go('{$_POST['HTTP_REFERER']}')"));
}

function sql_split($sql){
	$db=new db();
	$version=$db->version();
	$version=str_ireplace('MySQL/', '', $version);
	if($db->version() > '4.1' && DB_CHARSET){
		$sql = preg_replace("/TYPE=(InnoDB|MyISAM)( DEFAULT CHARSET=[^; ]+)?/", "TYPE=\\1 DEFAULT CHARSET=".DB_CHARSET,$sql);
	}
	$sql = str_replace("\r", "\n", $sql);
	$ret = array();
	$num = 0;
	$queriesarray = explode(";\n", trim($sql));
	unset($sql);
	foreach($queriesarray as $query){
		$ret['sql'][$num] = '';
		$queries = explode("\n", trim($query));
		$queries = array_filter($queries);
		foreach($queries as $query){
			$str1 = substr($query, 0, 1);
			if($str1 != '#' && $str1 != '-') {
				$ret['sql'][$num] .= $query;
			}else{
				$ret['info'].= $query;
			}
		}
		$num++;
	}
	return($ret);
}

function sql_execute($sql, $tablepre=DB_PRE){
	$db=new db();
    $split = sql_split($sql);
	$sqls  = $split['sql'];
	$info  = $split['info'];
	if(is_array($sqls)){
		foreach($sqls as $sql){
			$sql=str_replace('king_',$tablepre.'_',$sql);
			if(trim($sql) != ''){
				if($db->safecheck($sql)){
					@mysql_query($sql);
				}
			}
		}
	}
	else{
		$sqls=str_replace('king_',$tablepre.'_',$sqls);
		if($db->safecheck($sqls)){
			@mysql_query($sqls);
		}
	}
	return true;
}
//将G M K转换为字节
function return_bytes($val){
    $val = trim($val);
    $last = strtolower($val[strlen($val)-1]);
    switch($last){
        case 'g':
            $val *= 1024;
        case 'm':
			$val *= 1024;
        case 'k':
            $val *= 1024;
    }
    return $val;
}

function make_backup_name(){
    $pre = date('Ymd_',time()); //前缀
    $No_have_been = array(); //当天已经有的备份序号
	$backup_path=ROOT.'databack/sql';
	if(!file_exists(ROOT.'databack/sql')){
		$file=new file;
		$file->md('databack/sql');
	}
    if ($handle = opendir($backup_path)){
            while (($file = readdir($handle)) !== false) {
                    if ($file{0} != '.' && filetype($backup_path.'/'.$file) == 'dir') {
                        if (strpos($file, $pre) === 0) {
                            $No = intval(str_replace($pre, '', $file)); //当天的编号
                            if ($No) {
                                $No_have_been[] = $No;
                            }
                        }
                    }
            }
    }
    if ($No_have_been) {
       $pre .= max($No_have_been)+1;
    } else {
       $pre .= '1';
    }
    return $pre;
}

function formatBytes($bytes) {
	if($bytes >= 1073741824) {
		$bytes = round($bytes / 1073741824 * 100) / 100 . 'GB';
	} elseif($bytes >= 1048576) {
		$bytes = round($bytes / 1048576 * 100) / 100 . 'MB';
	} elseif($bytes >= 1024) {
		$bytes = round($bytes / 1024 * 100) / 100 . 'KB';
	} else {
		$bytes = $bytes . 'Bytes';
	}
	return $bytes;
}
//随机函数
function met_rand($length){
	$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
	$password = '';
	for ( $i = 0; $i < $length; $i++ ) {
		$password .= $chars[ mt_rand(0, strlen($chars) - 1) ];
	}
	return $password;
}

function sql_dumptable($table, $startfrom = 0, $currsize = 0, $sizelimit){
	$db=new db;
	$tabledump = '';
	$offset = 100;
	if(!$startfrom){
		$tabledump = "DROP TABLE IF EXISTS $table;\n";
		$create = $db->get("SHOW CREATE TABLE $table");
		$tabledump .= str_replace(strtolower($table),$table,$create[0]['Create Table']).";\n\n";
	}

	$tabledumped = 0;
	$numrows = $offset;
	while($currsize + strlen($tabledump) < $sizelimit * 1000 && $numrows == $offset){
		$tabledumped = 1;
		$rows = $db->query("SELECT * FROM $table LIMIT $startfrom, $offset");
		$numfields=mysql_num_fields($rows);
		$numrows = mysql_num_rows($rows);
		while ($row = mysql_fetch_row($rows)){
			$comma = "";
			$tabledump .= "INSERT INTO $table VALUES(";
			for($i = 0; $i < $numfields; $i++){
				$tabledump .= $comma."'".mysql_escape_string($row[$i])."'";
				$comma = ",";
			}
			$tabledump .= ");\n";
		}
		$startfrom += $offset;
	}
	$startrow = $startfrom;
	$tabledump .= "\n";
	$array = array('tabledump'=>$tabledump,'startrow'=>$startrow);
	unset($tabledump);
	return $array;
}
?>