<?php
require '../global.php';

function _edit(){
	$u=new user;$u->auth_role('user_node_edit');
	$str=new str;
	if(empty($_POST['name'])) kc_tip('节点名称不能为空!','form');
	if($str->len($_POST['name'])>50) kc_tip('节点名称超过限定','form');
	if(empty($_POST['url'])) kc_tip('节点代号不能为空!','form');
	if($str->len($_POST['url'])>50) kc_tip('节点代号长度超过限定','form');
	if(!kc_validate($_POST['url'],'/^[a-z0-9_]*$/')) kc_tip('节点代号只能由英文字母开头，由数字、字母或下划线构成!','form');
	$id=kc_post('id',2,0);
	$db=new db;
	
	$array=array(
		'name'=>$_POST['name'],
		'url'=>$_POST['url'],
		'description'=>$_POST['description'],
	);
	if(empty($id)){
		$array['cid']=kc_post('cid',2,1);
		$db->insert('%s_node',$array);
	}else{
		$rs=$db->getRows_one('%s_node','cid','id='.$id);
		if(empty($rs)) kc_tip('当前记录已被删除!');
		$db->update('%s_node',$array,'id='.$id);
	}
	
	$referer=kc_post('HTTP_REFERER');
	kc_ajax(array('JS'=>"go('$referer')"));

}

function _delete(){
	$u=new user;$u->auth_role('user_node_delete');

	$id=kc_get('id',2,1);
	
	$db=new db;
	$db->delete('%s_node',"id in($id)");

	kc_ajax(array('JS'=>"\$('".preg_replace('/([0-9]+)/','#tr$1',$id)."').remove();\$.kc_close();"));
}
//排序
function _order(){
	$u=new user;$u->auth_role('user_node_edit');
	$id=kc_post('id',2,1);
	if(!kc_validate($_POST['val'],2)) kc_tip('提交值必须为数字!','form');
	if(strlen($_POST['val'])>10) kc_tip('提交值不能超过十位数!','form');
	$db=new db;
	$db->update('%s_node',array('norder'=>$_POST['val']),'id='.$id);
	kc_ajax(array('JS'=>"\$.kc_close();"));
}

function _edit_cat(){
	$u=new user;$u->auth_role('user_node_edit');
	$str=new str;
	if(empty($_POST['name'])) kc_tip('分类名称不能为空!','form');
	if($str->len($_POST['name'])>50) kc_tip('分类名称超过限定','form');
	if(empty($_POST['url'])) kc_tip('分类代号不能为空!','form');
	if($str->len($_POST['url'])>50) kc_tip('分类代号长度超过限定','form');
	if(!kc_validate($_POST['url'],'/^[a-z][a-z0-9\_]*$/')) kc_tip('分类代号必须英文字母开头，并由数字和英文字母构成!','form');
	$cid=kc_post('cid',2,0);
	$db=new db;
	
	$array=array(
		'name'=>$_POST['name'],
		'url'=>$_POST['url'],
		'description'=>$_POST['description'],
	);
	if(empty($cid)){
		$db->insert('%s_node_cat',$array);
	}else{
		$db->update('%s_node_cat',$array,'cid='.$cid);
	}
	
	$referer=kc_post('HTTP_REFERER');
	kc_ajax(array('JS'=>"go('$referer')"));
}

function _delete_cat(){
	$u=new user;$u->auth_role('user_node_delete');

	$cid=kc_get('cid',2,1);
	
	$db=new db;
	
	$db->delete('%s_node_cat',"cid in($cid)");
	$db->delete('%s_node',"cid in($cid)");

	kc_ajax(array('JS'=>"\$('".preg_replace('/([0-9]+)/','#tr$1',$cid)."').remove();\$.kc_close();"));
}
//排序
function _order_cat(){
	$u=new user;$u->auth_role('user_node_edit');
	$cid=kc_post('cid',2,1);
	if(!kc_validate($_POST['val'],2)) kc_tip('提交值必须为数字!','form');
	if(strlen($_POST['val'])>10) kc_tip('提交值不能超过十位数!','form');
	$db=new db;
	$db->update('%s_node_cat',array('norder'=>$_POST['val']),'cid='.$cid);
	kc_ajax(array('JS'=>"\$.kc_close();"));
}