<?php
require '../global.php';

//加载文件
function _load(){
	$u=new user;
	$u->auth_role('template_edit');
	$filename=kc_get('filename','/^([a-zA-Z0-9\_\-]+\/)*[a-z0-9A-Z\_\-]+\.[a-z0-9]{2,8}$/',1);
	$file=new file;
	$s=$file->get(T.$filename);
	$array=json_encode(array('content'=>$s));
	$js="\$.kc_setvalue('#form_publish',$array);";
	kc_ajax(array('JS'=>$js));
}
//编辑文件
function _edit(){
	$u=new user;
	$u->auth_role('template_edit',false,true);
	$filename=kc_get('filename','/^([a-zA-Z0-9\_\-]+\/)*[a-z0-9A-Z\_\-]+\.[a-z0-9]{2,8}$/',1);
	$content=empty($_POST['content'])?'':$_POST['content'];
	$file=new file;
	$file->put(T.$filename,$content);
	kc_ajax(array('JS'=>"\$('#theme_after').html('').hide();"));
}
//删除文件
function _delete(){
	$u=new user;
	$u->auth_role('template_delete',false,true);
	$filename=kc_get('filename','/^([a-zA-Z0-9\_\-]+\/)*[a-z0-9A-Z\_\-]+\.[a-z0-9]{2,8}$/',1);
	$file=new file;
	$file->delete(T.$filename);
	kc_ajax(array('JS'=>"go('{$_POST['HTTP_REFERER']}');"));
}
//文件重命名
function _rename(){
	$u=new user;
	$u->auth_role('template_rename',false,true);
	$filename=kc_get('filename','/^([a-zA-Z0-9\_\-]+\/)*[a-z0-9A-Z\_\-]+\.[a-z0-9]{2,8}$/',1);
	$oldname=kc_get('oldname','/^([a-zA-Z0-9\_\-]+\/)*[a-z0-9A-Z\_\-]+\.[a-z0-9]{2,8}$/',1);
	if($oldname==$filename){
		kc_tip('新文件名和原文件名一致!','form');
	}
	if(!is_file(ROOT.T.$oldname)){
		kc_tip('原文件名不存在!','form');
	}
	$dirname=dirname(ROOT.T.$filename);
	if(!is_dir($dirname)){
		@mkdir($dirname,0755,true);
	}
	@rename(ROOT.T.$oldname,ROOT.T.$filename);
	kc_ajax(array('JS'=>"go('{$_POST['HTTP_REFERER']}');"));
}
//删除文件夹
function _delete_dir(){
	$u=new user;
	$u->auth_role('template_delete',false,true);
	$path=kc_get('path','/^([a-zA-Z0-9\_\-]+\/)*$/',1);
	if(empty($path)) kc_tip('系统拒绝删除根目录!','form');	
	if(!is_dir(ROOT.T.$path)) kc_tip('您要删除的目录不存在!','form');	
	$file=new file;
	$file->rd(T.$path);
	$path=dirname($path);
	$path=$path=='.'?'':urlencode($path.'/');
	kc_ajax(array('JS'=>"go('?_=template&path=$path');"));
}
//创建目录
function _create_dir(){
	$u=new user;
	$u->auth_role('template_edit',false,true);
	$path=kc_get('path','/^([a-zA-Z0-9\_\-]+\/)*$/',1);
	if(empty($path)) kc_tip('请输入您要创建的目录!','form');
	if(is_dir(ROOT.T.$path)) kc_tip('您要创建的目录已经存在!','form');	
	@mkdir(ROOT.T.$path,0755,true);
	$path=urlencode($url);
	kc_ajax(array('JS'=>"go('?_=template&path=$path');"));
}
//安装
function _install(){
	$u=new user;
	$u->auth_role('template_install',false,true);
	$prod=kc_get('prod',4,1);
	$path=kc_get('path',4,1);
	$file=new file;
	$s='<p id="k_content"><strong>请不要关闭下载窗口!</strong>';
	$s.='</p>';
	kc_ajax(array(
		'TITLE'=>'安装应用',
		'MAIN'=>$s,
		'ID'=>'kc_ajax',
		'WIDTH'=>550,
		'HEIGHT'=>230,
		'JS'=>"\$.kc_ajax({URL:'".FULLURL."user/manage_template.php',CMD:'getfile','key':0,prod:'$prod',path:'$path'});",//files:'".serialize($showfiles['file'])."',
		'BUTTON'=>"<button onclick=\"go('".(empty($_POST['HTTP_REFERER'])?'./':$_POST['HTTP_REFERER'])."');$.kc_close();return false;\">确定</button>",
	));
}
//更新/config.php文件
function _setconfig(){
	$u=new user;
	$u->auth_role('admin',false,true);
	$path=kc_post('path',4,1);
	$file=new file;
	$config=$file->get('config.php');
	$config=preg_replace("/(define\('T','[A-Za-z0-9\_]+\/)[A-Za-z0-9\_]+(\/'\);)/","\$1{$path}\$2",$config);//define('T','templates/orange/');
	$file->put('config.php',$config);
	kc_tip('更新成功!','ok');
}
//获得远程php或图像文件
function _getfile(){
	$u=new user;
	$u->auth_role('template_install');
	$key=kc_post('key',2,1);
	$prod=kc_get('prod',4,1);
	$path=kc_get('path',4,1);
	$tpath=dirname(T);
	$db=new db;
	$file=new file;
	$js='';

	$getdata=file_get_contents(SERV.'/'.VERSION.'/getfile.php?type=template&prod='.$prod.'&path='.$path.'&key='.$key.'&siteurl='.urlencode(SITEURL));
	
	if(!empty($getdata)){
		$un_data=@unserialize($getdata);
		if(isset($un_data['data']) && isset($un_data['filepath'])){
			if(!empty($un_data['dir'])){
				foreach($un_data['dir'] as $k=>$v){
					$js.="\$('#k_content>strong').after('<br/><span><em>√</em> &nbsp; [目录] {$path}/{$v}/</span>');";
					$file->md('templates/'.$path.'/'.$v);
				}
			}
			$filepath=$un_data['filepath'];
			$data=base64_decode($un_data['data']);
			if(preg_match('/^images\/(.+)\.(jpeg)$/',$filepath,$mat)){//如果遇到图片文件，则不做覆盖操作
				if(is_file(ROOT.'templates/'.$path.'/'.$filepath)){
					$data_local=file_get_contents(ROOT.'templates/'.$path.'/'.$filepath);
					if($data!=$data_local){
						$file->put('templates/'.$path.'/'.$filepath.'.new',$data);
					}
				}
			}else{
				if(is_file(ROOT.'templates/'.$path.'/'.$filepath)){
					$data_local=file_get_contents(ROOT.'templates/'.$path.'/'.$filepath);
					if($data!=$data_local){
						$file->put('templates/'.$path.'/'.$filepath.'.bak',$data_local);
					}
				}
				$file->put('templates/'.$path.'/'.$filepath,$data);
			}
			$js.="\$('#k_content>strong').after('<br/><span><em>√</em> &nbsp; [文件] {$filepath}</span>');";
		}else{
			kc_tip('数据格式错误!');
		}
	}else{
		$reshipment=addcslashes("\$('#k_content>span').remove();\$.kc_ajax({URL:'".FULLURL."user/manage_template.php',CMD:'getfile','key':0,prod:'$prod',path:'$path'});","'");
		$js.="\$('#k_content>strong').after('<br/><span>成功扩展对应模版! <a href=\"javascript:;\" onclick=\"$reshipment\">[重装]</a></span>');";
		kc_ajax(array('JS'=>$js));
	}	
	//如果是sql文件的话，需要执行sql代码
	if(preg_match('/^sql\/(\d+)\.sql$/',$filepath,$mat)){
		$sql=str_replace('king_',DB_PRE.'_',$data);
		$array=explode(';',$sql);
		array_pop($array);
		foreach($array as $q){
			$db->query($q);
		}
	}elseif(preg_match('/^update\/(\d+)\.php$/',$filepath,$mat)){//php升级程序
		require ROOT.$path.'/'.$filepath;
	}elseif(preg_match('/task\/(\w+\/.+?\.php)/',$filepath,$mat)){//任务文件
		$file->put('user/task/'.$mat[1],$data);
	}	
	$key++;
	$js.="\$.kc_ajax({URL:'".FULLURL."user/manage_template.php',CMD:'getfile','key':$key,path:'$path',prod:'$prod'});";//files:'".serialize($files)."',
	kc_ajax(array('JS'=>$js));
}
?>