<?php
require '../global.php';

//点击验证码框的时候，激活这个函数
function _check(){
	$ajax=empty($_POST['ajax'])?0:1;

	$n1=rand(11,99);// 第一位
	$n2=rand(2,9);// 第二位数
	$op1=rand(1,2);// 选项
	if($op1==1){ $answer=$n1+$n2;$quest=$n1.'+'.$n2;
	}elseif($op1==2){ $answer=$n1-$n2;$quest=$n1.'-'.$n2;
	}elseif($op1==3){ $answer=$n1*$n2;$quest=$n1.'x'.$n2;}

	$db=new db;
	$array=array(
		'answer'=>$answer,
		'quest'=>$quest,
		'date'=>time(),
	);

	$id=$db->insert('%s_checkcode',$array);
	$js="\$('#checkcode_id$ajax').val('$id');";
	$js.="\$('#checkcode_up$ajax').show();";
	$js.="\$('#checkcode_img$ajax').html('<img src=\"".DIR."user/checkcode.php?id=$id\" onclick=\"checkcode_click(1)\"/>');";
	kc_ajax(array('JS'=>$js));

}
//发送邮箱验证码
function _emailcheck(){
	$useremail = trim($_POST['email']);
	if(empty($useremail)) kc_tip('请先填写电子邮箱!','form');
	
	$verify_code = generate_code(10);
	$md5word = md5($verify_code);
	$site_url = FULLURL;
	$site_name = kc_config('site.name');
	$mail_send_time = time();
	if(kc_checkApp('email')){
		include_once(ROOT.'apps/email/mail_queue.class.php');
		$mail_queue	= new mail_queue;
		$email = $mail_queue->get_mail_template('user_register');
		if(!$email){
			$errstr = $mail_queue->show_errstr();
			kc_tip($errstr,'form');
		}
		$email_subject = $email['tpltitle'];
		$email_content = $mail_queue->_eval($email['content'], array(
			'verify_code'=>$verify_code,
			'site_name'=>$site_name
		));
		$email_type = $email['tpltype'];

		if($mail_queue->send_mail('', $useremail, $email_subject, $email_content, $email_type)){
			$db=new db;
			$activate_arr = array(
				'user_id' => 0,
				'email' => $useremail,
				'add_time'=> time(),
				'activation' => $md5word
			);
			$id=$db->insert('%s_email_activate',$activate_arr);
			$js="\$('#email_captcha_id').val('$id');alert('验证邮件成功发送,请注意查收');";
			kc_ajax(array('JS'=>$js));
		}else{
			$errstr = $mail_queue->show_errstr();	
			kc_ajax(array('JS'=>"alert('$errstr');"));
		}	
	}else{
		kc_tip('[邮件助手]应用未安装，请与管理员联系!','form');
	}
}

function generate_code($len = 15){
    $chars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    for ($i = 0, $count = strlen($chars); $i < $count; $i++){
        $arr[$i] = $chars[$i];
    }

    mt_srand((double) microtime() * 1000000);
    shuffle($arr);
    $code = substr(implode('', $arr), 5, $len);
    return $code;
}
//发送手机验证码
function _smscheck(){
	$phone = $_POST['phone'];
	if(empty($phone)) kc_tip('请先填写手机号码!','form');

	$db=new db;
	$res=$db->getRows_one('%s_sms_config','*',"status='system'");
    mt_srand((double) microtime() * 1000000);
    $verify_code = mt_rand(100000, 999999);
	$valid_time = $res['captcha_valid_time'];
	$site_name = kc_config('site.name');
	
	$array=array(
		'phone'=>$phone,
		'captcha'=>$verify_code,
		'add_time'=>time(),
		'end_time'=>time()+$res['captcha_valid_time']*60
	);
	$sms=new sms;
	$message = $sms->getcontent('send_sms_code');
	eval("\$message = \"$message\";");
	$u=new user;
	$sms_info =array(
		'userid'=>$u->info['userid'],
		'sms_mobno'=>$phone,
		'sms_content'=>$message,
		'addtime'=>time(),
	);
	$sms->send($sms_info);	//发送短信
	if($errstr = $sms->show_errstr()){
		kc_ajax(array('JS'=>"alert('$errstr');"));
	}else{
		$id=$db->insert('%s_sms_captcha',$array);
		$js="\$('#sms_captcha_id').val('$id');time(\$('#sendMobileCode')[0]);";
		kc_ajax(array('JS'=>$js));
	}
}

ob_end_clean();

header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // 过去的时间
define('CLOSETASK',true);//关闭任务

$db=new db;
$id=kc_get('id',2,1);
$rs=$db->getRows_one('%s_checkcode','quest','id='.$id);
$quest=empty($rs)?'xxxxxx':$rs['quest'].'=?';
$arr=require ROOT.'user/font.php';

$width=95;
$height=28;
$move=5;//偏移值设定
$space=15;//字间距
$alpha=85;//透明度
$slants=128;//色彩偏移值

$im=imagecreatetruecolor($width,$height);//创建空白图片
$color=imagecolorallocate($im,255,255,255); //填充白色背景，默认黑色
imagefill($im,$width,$height-1,$color);
$bg=imagecreatefromjpeg(ROOT.'images/checkcode.jpg');
$bgx=imagesx($bg);
$bgy=imagesy($bg);
imagecopymerge($im,$bg,0,0,rand(0,$bgx-$width),rand(0,$bgy-$height),$width,$height,$alpha);

for($i=0;$i<strlen($quest);$i++){
	$font=$arr[$quest{$i}];//获得一个个文字对应的数组
	//赋一个整体颜色
	$r1=rand(0,255); $g1=rand(0,255); $b1=rand(0,255);
	$k_rand=rand(-$move,$move);//Y轴整体漂移
	$x_rand=$move;//X轴偏移量
	foreach($font as $k=>$r){
		$r1+=rand(-$slants,$slants); $g1+=rand(-$slants,$slants); $b1+=rand(-$slants,+$slants);//颜色渐变
		$x_rand+=rand(-1,1);
		if($x_rand<0) $x_rand=0;
		if($x_rand>$move*3) $x_rand=$move*3;
		$k1=$k+$k_rand;
		for($j=0;$j<strlen($r);$j++){//前面填充了N个0
			$c=$r{$j};
			if(!empty($c)){
				$x=$i*$space+$j+$x_rand;
				$y=$k1+$move+2;
				//$c=256*(8-$c)/8;
				$pct=(8-$c)/8;
				//红 蓝 绿 255:白色  0:黑色
				$r2=$r1*$pct; $g2=$g1*$pct; $b2=$g1*$pct;
				$r2=$r2<0?0:$r2;$r2=$r2>255?255:$r2;
				$g2=$g2<0?0:$g2;$g2=$g2>255?255:$g2;
				$b2=$b2<0?0:$b2;$b2=$b2>255?255:$b2;
				$color=imagecolorallocate($im,round($r2),round($g2),round($b2));//$r[$j];
				imagesetpixel($im,$x,$y,$color);
			}
		}
	}
}
header('Content-type: image/jpeg');
imagejpeg($im);
?>