<?php

/**
 * 用户访问控制
 */
class user{
	//@var array 用户信息
	public $info;
	public $id;
	public $name;
	public function __construct(){
		$cookie=kc_cookie('userauth');
		$cookiePass=substr($cookie,0,32);

		$ischeck=true;//是否审核cookie

		$GLOBALS['db']=new db;
		$GLOBALS['str']=new str;
		$GLOBALS['cache']=new cache;

		global $db,$str;//设置为全局变量

		if(!empty($_GET['jsoncallback']) && !empty($_GET['USERID']) && !empty($_GET['SIGN'])){
			$get_userid=$_GET['USERID'];
			$get_sign=$_GET['SIGN'];
			$sign=md5($get_userid.SITEURL.kc_config('system.salt'));
			$userid = $sign==$get_sign ? $get_userid : 0;
			
			$ischeck=false;
			
		}else{
			$userid=substr($cookie,32);
		}
		
		if(!kc_validate($userid,2)) $userid=0;

		if(empty($userid)){
			$user=array('userpass'=>'x');
		}else{
			$user=$db->getRows_one('%s_user','*','userid='.$userid);
			if(empty($user)) $user=array('userpass'=>'x');
		}
		//用户已登录
		if (md5($user['userpass'])==$cookiePass || $ischeck==false) {
			//更新在线时间
			$zx=time()-$user['date'];
			if($zx<300){
				$array=array(
					'[zaixian]'=>'zaixian+'.$zx,
					'date'=>time(),
					'ip'=>$str->ip(),
				);
				$user['onlinetime']=$zx;
			}else{
				$array=array('date'=>time());
				$user['onlinetime']=0;
			}
			$db->update('%s_user',$array,'userid='.$userid);
			$user_group=$db->getRows_one('%s_user_group_bind','gid','userid='.$user['userid']);
			$user['gid']=$user_group['gid'];
			unset($user['userpass']);
			$user['islogin']=true;
		}else{
			$user=array(
				'userid'=>'0',
				'username'=>'[匿名]',
				'islogin'=>false,
				'regip'=>0,
				'gid'=>0,
				'name'=>'',
				'tel'=>'',
				'email'=>'',
				'qq'=>'',
				'address'=>'',
				'onlinetime'=>0,
				'sess_id'=>'',
			);
		}
		
		$this->id=$userid;
		$this->name=$user['username'];
		$this->info=$user;
		unset($user);

		if(!defined('CLOSETASK')){
			$file=new file;
			$tasks=$file->getDir('user/task/init/','php');
			
			if(!empty($tasks)){
				foreach($tasks as $k => $v){
					require ROOT.$k;
				}
			}
			unset($tasks);
		}

		return $this->info;
	}

	public function __destruct(){
		flush();
		if(!is_dir(ROOT.'user/task')) return false;
		if(AJAX) return false;//ajax操作的时候不做计划任务
		if(defined('CLOSETASK')) return false;

		extract($this->info);
		//分时计划任务
		$file=new file;
		$db=new db;
		$time=time();
		$today=date('Ymd',$time);

		for($i_task=1;$i_task<=6;$i_task++){
			if ($time-intval(kc_config('task.update'.$i_task))>(3600*$i_task)){
				$tasks=$file->getDir('user/task/'.$i_task.'/','php');
				if(!empty($tasks)){
					foreach ($tasks as $k =>$v) {
						require ROOT.$k;
					}
				}
				unset($tasks);
				$db->update('%s_config',array('value'=>$time),"class='task' and name='update{$i_task}'");
			}
		}
		//开始执行每日计划任务
		if(kc_config('task.day')!=$today){
			$tasks=$file->getDir('user/task/day/','php');
			if(!empty($tasks)){
				foreach($tasks as $k => $v){
					require ROOT.$k;
				}
			}
			unset($tasks);
			$db->update('%s_config',array('value'=>$today),"class='task' and name='day'");
		}
		//刷新即可执行
		$tasks=$file->getDir('user/task/0/','php');
		if(!empty($tasks)){
			foreach($tasks as $k=>$v){
				require ROOT.$k;
			}
		}
	}
	/**
	 * 访问前台会员权限验证,无返回值，直接提示错误
	 * @param string&array $level 可访问的权限,0:匿名可访问 1:登录用户才访问 array:多重验证，通过一个即可
	 * @param string $is true的时候返回登录状态值,默认仅检测并输出错误!
	 */
	public function auth_group($level=0,$is=false){
		if(empty($level)) return $this->info['islogin'];
		$db=new db;

		if($this->info['islogin']){
			if($this->auth_role($level,true)) return true;
		}

		$userid=$this->info['userid'];
		if(empty($userid)){
			$where="t1.gid=0 and t1.auth='$level'";
		}else{
			$where="(t2.userid=$userid or t1.gid in (0,1)) and t1.auth='$level'";
		}
		$rs=$db->getRows_join('%s_user_group_auth','%s_user_group_bind','auth','gid','gid',$where);

		return empty($rs) ? ($is ? false : kc_tip('您无权访问当前页！','form')) : true;
	}

	public function auth_role($level=0,$is=false,$checkback=false){
		/* 检查来源及数据合法完整性 */
		if($checkback){
			$get_userid=$_GET['USERID'];
			$get_sign=$_GET['SIGN'];
			$sign=md5($get_userid.SITEURL.kc_config('system.salt'));
			if($sign!=$get_sign) kc_tip('您无权访问当前页！','form');
		}

		if(empty($level)) return $this->info['islogin'];
		if($level==1 && !$this->info['islogin']) return $is ? false :kc_tip('请先登录！','form');

		if($is==true && strpos($level,'_deny')) return false;
		
		$db=new db;
		$res_rids=$db->getRows_two('%s_user_role_bind','rid','removedate','userid='.$this->info['userid']);

		if(!empty($res_rids)){
			$rids=array_keys($res_rids);
			$rs=$db->getRows_two('%s_user_role_auth','auth','id','rid in ('.implode(',',$rids).')');
			if(!empty($rs['admin'])) return true;
		}
		return empty($rs[$level]) ? ($is ? false : kc_tip('您无权访问当前页！','form')) : true;
	}
	/**
	 * 获得积分操作对象值
	 * @param string $app 应用代号
	 * @param string $code 应用对应操作值
	 * @return array 键值为pointid的对象值
	 */
	public function getPointAction($app,$code){
		$db=new db;
		$res=$db->getRows_join('%s_point_value','%s_point','pointid,value','pointname','pointid',"t1.app='$app' and t1.code='$code'");
		$array=array();
		foreach($res as $rs){
			$rs['value']=$rs['value']>0?'+'.$rs['value']:$rs['value'];
			$array[$rs['pointid']]=$rs;
		}
		return $array;
	}
	/**
	 * 操作积分值
	 * @param string $app 应用名称
	 * @param string $code 积分代号
	 * @param integer $userid 被操作的用户
	 * @return boolean 成功返回true
	 */
	public function setPoint($app,$code,$userid=null,$codename='',$appname=''){
		$db=new db;
		$res=$db->getRows_join('%s_point_value','%s_point','pointid,value','pointname','pointid',"t1.app='$app' and t1.code='$code'");
		$userid=empty($userid)?$this->id:$userid;	
		
		if(empty($userid)) return false;
		
		$user_point=$db->getRows_two('%s_user_point','pointid','value','userid='.$userid);
		foreach($res as $rs){
			if($rs['value']<0 && ($user_point[$rs['pointid']]+$rs['value']<0)){
				kc_tip('您的'.$rs['pointname'].'不足，无法支付本次操作!','error');
			}
		}

		foreach($res as $rs){
			$array=array(
				'userid'=>$userid,
				'pointid'=>$rs['pointid'],
				'value'=>$rs['value'],
			);
			$db->insert('%s_user_point',$array,false,'value=value+('.$rs['value'].')');

			//积分操作日志
			$array['app']=$app;
			$array['code']=$code;
			$array['codename']=$codename;
			$array['appname']=$appname;
			$array['addtime']=time();
			$db->insert('%s_user_point_log',$array);
		}

	}

	/* 单项操作积分
	 * @param integer $userid 被操作的用户
	 * @param integer $pointid 积分类型
	 * @param integer $value 操作值
	 */
	public function setPoint_one($userid,$pointid,$value,$app,$code,$codename='',$appname=''){
		$db=new db;
		if(empty($userid)) kc_tip('<p>匿名用户不能操作积分！</p>','form');
		if(!kc_validate($userid,2)) kc_tip('<p>会员名参数错误！</p>','form');
		if(!kc_validate($pointid,2)) kc_tip('<p>积分参数错误！</p>','form');
		if(strlen($value)>10) kc_tip('<p>数据超出预期!','form');

		$rs_point=$db->getRows_one('%s_user_point','value',"userid=$userid and pointid=$pointid");
		$val=empty($rs_point)?0:$rs_point['value'];
		if($value+$val<0) kc_tip('<p>操作结果不能为负数！</p>','form');

		$array=array(
			'userid'=>$userid,
			'pointid'=>$pointid,
			'value'=>$value,
		);
		$db=new db;
		$db->insert('%s_user_point',$array,false,'value=value+('.$value.')');

		$array['app']=$app;
		$array['code']=$code;
		$array['addtime']=time();
		$array['codename']=$codename;
		$array['appname']=$appname;
		$db->insert('%s_user_point_log',$array);
	}

	public function getInfo($userid){
		$db=new db;
		if(!empty($userid)){
			$rs=$db->getRows_one('%s_user','*','userid='.$userid);
		}
		if(empty($rs)){
			$rs=array(
				'userid'=>0,'username'=>'[匿名]','userpass'=>'',
				'salt'=>0,'regdate'=>0,'regip'=>0,'name'=>'',
				'tel'=>'','email'=>'','qq'=>'','address'=>'','quest'=>'',
				'answer'=>'','zaixian'=>0,'date'=>0,'ip'=>0,'qianming'=>'',
				'sex'=>0,'dailycheck'=>0,'perfectinfo'=>0
			);
		}
		return $rs;
	}

	public function getPoint($userid){
		$db=new db;

		$rs_point=array();
		$res_point=$db->getRows('%s_point','pointid,pointname','','norder,pointid');
		foreach($res_point as $r){
			$rs_point[$r['pointid']]=array('value'=>0,'name'=>$r['pointname']);
		}
		$res_point_v=$db->getRows('%s_user_point','pointid,value','userid='.$userid);
		foreach($res_point_v as $r){
			if(isset($rs_point[$r['pointid']])){
				$rs_point[$r['pointid']]['value']=$r['value'];
			}else{
				$db->delete('%s_user_point','pointid='.$r['pointid'].' and userid='.$userid);
			}
		}
		return $rs_point;

	}
	//检查是否为管理员
	public function isAdmin(){
		$db=new db;
		$rs=$db->getRows_one('%s_user_role_bind','rid','userid='.$this->id);
		return empty($rs)?false:true;
	}	
	//短信操作
	public function sendsms($userid, $act='register'){
		$db=new db;
		$rs=$db->getRows_one('%s_user','username,mobile','userid='.$userid);
		if(empty($rs)) return false;
		$mobile = $rs['mobile'];
		$username = $rs['username'];
		$sms_app=$db->getRows_one('%s_app','*',"path='sms'");
		if(empty($sms_app)) return false;
		$sms_conf=$db->getRows_one('%s_sms_config','*',"{$act}=1 AND status='system'");
		if(empty($sms_conf)) return false;
		include_once(ROOT.'apps/sms/sms.class.php');
		$sms=new sms();
		$message = $sms->getcontent('touser_register_notice');
		$site_name = kc_config('site.name');
		eval("\$message = \"$message\";");
		$sms_info =array(
			'userid'=>$userid,
			'sms_mobno'=>$mobile,
			'sms_content'=>$message,
			'addtime'=>time(),
		);
		$sms->send($sms_info);	//发送短信
	}
}
//用户等级
function user_level_number($t){
	$hour=$t/3600;
	$level= $hour>=1 ? ceil(sqrt($hour))+1 :1;
	return $level;
}
//用户等级图片
function user_level($t){
	$hour=$t/3600;
	$level= $hour>=1 ? ceil(sqrt($hour)) :1;
	$arr=array();
	$arr[1]=floor($level/16);
	$arr[2]=floor(($level-$arr[1]*16)/4);
	$arr[3]=$level-$arr[1]*16-$arr[2]*4;
	$s='<em class="level" title="Level:'.$level.'">';
	foreach($arr as $k=>$r){
		for($i=1;$i<=$r;$i++){
			$s.='<img src="'.DIR.T.'images/rank/r'.$k.'.gif" alt="用户等级"/>';
		}
	}
	$s.='</em>';
	return $s;
}
//验证APP安装
function app_check($app){
	$db=new db;
	$path=$db->encode($app);
	return $db->getRows_one('%s_app','*',"path='$path'");
}
//口碑等级 price:信用值 step:最低等级升级所需信用值
function koubei_level($price , $step = 100) {
	$level_1 = $step * 5;
    $level_2 = $level_1 * 6;
    $level_3 = $level_2 * 6;
    $level_4 = $level_3 * 6;
    $level_5 = $level_4 * 6;
	$s='<em class="level">';
    if ($price  < $level_1){
		$s.='<img src="'.DIR.T.'images/seller/heart_' . (floor($price / $step) + 1) . '.gif" alt="服务口碑"/>';
    }
    elseif ($price  < $level_2){
		$s.='<img src="'.DIR.T.'images/seller/diamond_' . (floor(($price - $level_1) / $level_1) + 1) . '.gif" alt="服务口碑"/>';
	}
	elseif ($price  < $level_3){
		$s.='<img src="'.DIR.T.'images/seller/crown_' . (floor(($price - $level_2) / $level_2) + 1) . '.gif" alt="服务口碑"/>';
	}
	elseif ($price  < $level_4){
        $s.='<img src="'.DIR.T.'images/seller/yellow_' . (floor(($price - $level_3) / $level_3) + 1) . '.gif" alt="服务口碑"/>';
    }
    else{
        $s.='<img src="'.DIR.T.'images/seller/level_end.gif" alt="服务口碑"/>';
    }
	$s.='</em>';
	return $s;
}
?>