<?php
require '../global.php';

//删除操作日志
function _delete_oplog(){
	$u=new user;
	$u->auth_role('admin');
	$id=kc_post('id',3,1);
	$db=new db;
	$db->delete('%s_log',"id in($id)");
	$referer=kc_post('HTTP_REFERER');
	kc_ajax(array('JS'=>"\$.kc_close();alert('成功删除操作日志!');go('$referer');"));
}
//参数设置
function _config(){
	$u=new user;
	$u->auth_role('config');
	$db=new db;
	$data=array();
	if (METHOD=='GET') {
		$res=$db->getRows('%s_config','name,value',"class='system'");
		foreach($res as $rs){
			$data[$rs['name']]=htmlspecialchars($rs['value']);
		}
		$data['name']=kc_config('site.name');
		$data['title']=kc_config('site.title');
		$data['keywords']=kc_config('site.keywords');
		$data['description']=kc_config('site.description');
	}else{
		if(empty($_POST['image_width'])||empty($_POST['image_height'])) kc_tip('请填写图像尺寸!','form');
		if(!kc_validate($_POST['image_width'],2)||!kc_validate($_POST['image_height'],2)) kc_tip('图像尺寸必须为数字!','form');
		$names=array('email','qq','tel','fax','beian','salt','image_width','lat','lng','image_height','head','countcode','bottom','icoimage','hotkeywords');
		foreach($names as $r){
			if(isset($_POST[$r]))
				$db->update('%s_config',array('value'=>kc_post($r)),"class='system' and name='$r'");
		}
		$db->update('%s_config',array('value'=>kc_post('name')),"class='site' and name='name'");
		$db->update('%s_config',array('value'=>kc_post('title')),"class='site' and name='title'");
		$db->update('%s_config',array('value'=>kc_post('keywords')),"class='site' and name='keywords'");
		$db->update('%s_config',array('value'=>kc_post('description')),"class='site' and name='description'");
		kc_tip('成功更新网站参数！','ok','refresh');
	}
	$s='<table>';
	$s.='<tr><th>网站名称：</th><td><input type="text" name="name" class="kc_ajaxinput" value="'.$data['name'].'"/></td></tr>';
	$s.='<tr><th>首页标题：</th><td><input type="text" name="title" class="kc_ajaxinput" value="'.$data['title'].'"/></td></tr>';
	$s.='<tr><th>首页关键词：</th><td><input type="text" name="keywords" class="kc_ajaxinput" value="'.$data['keywords'].'"/></td></tr>';
	$s.='<tr><th>首页META：</th><td><textarea name="description" class="kc_ajaxtext">'.$data['description'].'</textarea></td></tr>';
	$s.='<tr><th>E-Mail：</th><td><input type="text" name="email" class="kc_ajaxinput kc_ajaxwidth150" maxlength="50" value="'.$data['email'].'"/>';
	$s.='<label class="kc_ajaxlabel" style="color:#576780;font-size:14px;padding:0 8px 0 13px;">QQ：</label><input type="text" name="qq" class="kc_ajaxinput kc_ajaxwidth150" maxlength="15" value="'.$data['qq'].'"/></td></tr>';
	$s.='<tr><th>传真：</th><td><input type="text" name="fax" class="kc_ajaxinput kc_ajaxwidth150" maxlength="1000" value="'.$data['fax'].'"/>';
	$s.='<label class="kc_ajaxlabel" style="color:#576780;font-size:14px;">电话：</label><input type="text" name="tel" class="kc_ajaxinput kc_ajaxwidth150" maxlength="30" value="'.$data['tel'].'"/></td></tr>';
	$s.='<tr><th>备案号：</th><td><input type="text" name="beian" class="kc_ajaxinput kc_ajaxwidth150" maxlength="50" value="'.$data['beian'].'"/>';
	$s.='<label class="kc_ajaxlabel" style="color:#576780;font-size:14px;">图像尺寸：</label><input type="text" name="image_width" class="kc_ajaxinput kc_ajaxwidth40" maxlength="4" value="'.$data['image_width'].'"/><label class="kc_ajaxlabel">x</label>';
	$s.='<input type="text" name="image_height" class="kc_ajaxinput kc_ajaxwidth40" maxlength="4" value="'.$data['image_height'].'"/><label class="kc_ajaxlabel">单位:像素(PX)</label></td></tr>';
	$s.='<tr><th>密钥：</th><td><input type="text" name="salt" class="kc_ajaxinput" maxlength="32" value="'.$data['salt'].'"/>';
	$s.='<em class="kc_ajaxlabel">远程管理密钥,从KingCMS官网里的“<a href="http://go.focuznet.com/k9key" target="_blank">我的网站</a>”获取，本地调试(http://localhost/)下请留空</em></td></tr>';
	$s.='</table>';
	
	kc_ajax(array(
		'TITLE'=>'设置网站参数',
		'MAIN'=>$s,
		'ID'=>'kc_ajax',
		'WIDTH'=>600,
		'HEIGHT'=>530,
		'BUTTON'=>'<button onclick="$.kc_ajax({URL:\''.FULLURL.'/user/manage.php\',CMD:\'config\',FORM:\'kc_ajaxform\',METHOD:\'POST\'})">保存</button>',
	));
}
//开关设置
function _switch(){
	$u=new user;
	$u->auth_role('admin');
	$db=new db;
	$res=$db->getRows('%s_config','name',"class='switch'");
	foreach($res as $rs){
		$db->update('%s_config',array('value'=>empty($_POST[$rs['name']])?0:1),"class='switch' and name='{$rs['name']}'");
	}
	kc_tip('成功更新网站开关！','ok','refresh');
}
//上传水印
function _waterbutton(){
	$u=new user;
	$u->auth_role('admin');
	$id=kc_get('id',0,1);
	$s='<!DOCTYPE html>
	<html lang="zh-cn">
	<head>
		<meta charset="utf-8">
		<title>上传水印</title>
		<script charset="UTF-8" src="'.DIR.'user/js/jquery.js"></script>
		<script charset="UTF-8" src="'.DIR.'user/js/system.js"></script>
		<script charset="UTF-8" src="'.DIR.'user/js/ajaxupload.js"></script>
		<!--[if lt IE 9]>
		<script charset="UTF-8" src="'.DIR.'user/js/html5.js"></script>
		<![endif]-->
		<style type="text/css">html,body{padding:0;margin:0;}input{width:100px;height:30px;padding:0;margin:0;font-size:100px;cursor:pointer;}</style>
	</head>
	<body>
		<input id="up_menu" value="上传水印" type="submit" onclick="return false;"/>
		<script type="text/javascript">$.kc_upload(\'up_menu\',\''.$id.'\',\''.DIR.'user/manage.php?CMD=uploadwater\',\''.SERV.'?_=website\');</script>
	</body>
	</html>
	';
	exit($s);
}
//处理上传的水印
function _uploadwater(){
	$u=new user;
	$u->auth_role('admin');
	$path='images/water.png';
	$inputname='filedata';//表单文件域name
	/** 判断是否有图片上传，如果有图片上传，则对图片进行裁减处理 **/
	if (isset($_FILES[$inputname])) {
		$upfile=$_FILES[$inputname];
		if($upfile['error']==4){
			$upload_error='请选择要上传的文件';
		}else{
			//有文件上传的时候判断并提示
			if($upfile['size']>2097152){
				$upload_error='上传文件大小要小于2Mb，上传失败！'.$upfile['size'];
			}			
			$filename=$upfile['name'];//文件名
			$fext=strtolower(substr(strrchr($filename,'.'),1));
			//判断文件扩展名是否符合要求
			if(in_array($fext,array('jpg','jpeg','png'))){
				$fext= ($fext=='jpg') ? 'jpeg' : strtolower($fext);
			}else{
				$upload_error='水印图片类型只能是jpg,jpeg,png中的一种！';
			}
		}
		//没有错误的时候进行保存操作
		if (empty($upload_error)) {
			$file=new file;
			$file->md(dirname($path));
			//保存图片
			move_uploaded_file($upfile['tmp_name'], ROOT.$path);
		}else{
			echo "{'err':'".$upload_error."'}";
			exit();
		}
	}
}
//弹窗调用 显示水印图片
function _watershow(){
	$waterpath='water.png';
	//读取图片长宽尺寸
	$size=@getimagesize(ROOT.'/images/'.$waterpath);
	$_width=$size[0];
	$_height=$size[1];
	$w=$_width;
	$h=$_height;
	$size=580;
	if($w>$size){
		$w=$size;
		$h=round($size*($_height/$_width));
	}
	if($h>$size){
		$h=$size;
		$w=round($size*($_width/$_height));
	}
	$attrib=array('width'=>$w,'height'=>$h);
	$param=http_build_query($attrib);
	$s="<a class=\"kc_ajaximage\" href=\"".FULLURL."images/water.png\" target=\"_blank\"><img src=\"".FULLURL."images/water.png\"/></a>";
	kc_ajax(array(
		'TITLE'=>'水印预览<em>W='.$_width.'px,H='.$_height.'px</em>',
		'MAIN'=>$s,
		'ID'=>'kc_ajax',
		'WIDTH'=>($w+20),
		'HEIGHT'=>($h+20),
	));
}
//上传设置
function _upconfig(){
	$u=new user;
	$u->auth_role('admin');
	if(!kc_validate($_POST['imagesize'],2)) kc_tip('上传图片上限必须为数字!','form');
	if(!kc_validate($_POST['image_width'],2)) kc_tip('自动压缩图片宽度必须为数字!','form');
	if(!kc_validate($_POST['image_height'],2)) kc_tip('自动压缩图片高度必须为数字!','form');
	$db=new db;
	$res=$db->getRows('%s_config','name',"class='up'");
	foreach($res as $rs){
		$db->update('%s_config',array('value'=>kc_post($rs['name'])),"class='up' and name='{$rs['name']}'");
	}
	$db->update('%s_config',array('value'=>empty($_POST['upimage'])?0:1),"class='switch' and name='upimage'");
	$db->update('%s_config',array('value'=>$_POST['image_width']),"class='system' and name='image_width'");
	$db->update('%s_config',array('value'=>$_POST['image_height']),"class='system' and name='image_height'");
	$db->update('%s_config',array('value'=>$_POST['imagesize']),"class='up' and name='imagesize'");
	$db->update('%s_config',array('value'=>$_POST['imagetype']),"class='up' and name='imagetype'");
	
	$upfile=@$_FILES['watermark'];
	if(!empty($upfile['tmp_name'])){
		$watermark_path = ROOT.'images/water.png';
		$file=new file;
		$file->md(dirname($watermark_path));
		move_uploaded_file($upfile['tmp_name'], $watermark_path);
	}
	kc_tip('成功更新图片上传配置参数！','ok','refresh');
}
//上传文件设置
function _upfileconfig(){
	$u=new user;
	$u->auth_role('admin');
	if(!kc_validate($_POST['filesize'],2)) kc_tip('上传图片上限必须为数字!','form');
	$db=new db;
	$db->update('%s_config',array('value'=>kc_post('upfile')),"class='switch' and name='upfile'");
	$db->update('%s_config',array('value'=>kc_post('filesize')),"class='up' and name='filesize'");
	$db->update('%s_config',array('value'=>kc_post('filetype')),"class='up' and name='filetype'");
	$db->update('%s_config',array('value'=>empty($_POST['upfile'])?0:1),"class='switch' and name='upfile'");
	kc_tip('成功更新文件上传配置参数！','ok','refresh');
}
//限制访问
function _deny(){
	$u=new user;
	$u->auth_role('admin');
	$db=new db;	
	//净化IP地址
	$ip=$_POST['ip'];
	$ips=explode("\n",$ip);
	$ips=array_filter($ips);// 剔除空值
	$ips=array_unique($ips);// 剔除重复值
	$_POST['ip']=implode("\n",$ips);	
	//净化useragent信息
	$ua=$_POST['useragent'];
	$uas=explode("\n",$ua);
	$uas=array_filter($uas);// 剔除空值
	$uas=array_unique($uas);// 剔除重复值
	$_POST['useragent']=implode("\n",$uas);		
	$res=$db->getRows('%s_config','name',"class='deny'");
	foreach($res as $rs){
		$db->update('%s_config',array('value'=>$_POST[$rs['name']]),"class='deny' and name='{$rs['name']}'");
	}
	kc_tip('成功更新限制访问内容！','ok','refresh');
}
//[管理员]重设密码
function _resetpass(){
	$u=new user;
	$u->auth_role('admin');
	$userid=kc_post('userid',2,1);
	if($userid==$u->info['userid']) kc_tip('要修改自己的密码，请点击“修改密码”!');	
    $str=new str;
	$pwd=$str->random(10);
	$db=new db;
	$db->update('%s_user',array('userpass'=>md5($pwd)),'userid='.$userid);
	kc_log(array('userid'=>$u->info['userid'],'app'=>'user','action'=>'USER_RESETPASS','cid'=>$userid));
	kc_tip('成功初始化用户密码：'.$pwd,'ok');
}
//登陆
function _login(){
	$GLOBALS['u']=new user;
	global $u;
	$db=new db;
	if($u->info['islogin']){
		$tip='您已经登陆! [<a href="javascript:;" onclick="$.kc_ajax({URL:\''.DIR.'user/manage.php\',CMD:\'logout\'})">退出</a>]';
		if($u->isAdmin()){
			$tip.='<br/>';
			$tip.='[<a href="javascript:;" onclick="$.kc_ajax({URL:\''.DIR.'user/manage.php\',CMD:\'updatepass\'})">重设密码</a>]';
			if($u->auth_role('config',true)){
				$tip.='[<a href="javascript:;" onclick="$.kc_ajax({URL:\''.DIR.'user/manage.php\',CMD:\'config\'})">参数设置</a>]';
			}
			$tip.='[<a href="'.sign_encode().'" target="_blank">后台管理</a>]';
		}
		kc_tip($tip,'ok');
	}
	if (METHOD=='GET') {
		$checkcode=new checkcode;
		$s='<table>';
		$s.='<tr><th>会员名：</th><td><input type="text" class="kc_ajaxinput kc_ajaxwidth200" name="username" maxlength="12" value="'.(empty($_POST['username'])?'':$_POST['username']).'"/></td></tr>';
		$s.='<tr><th>密码：</th><td>';
		$s.='<input type="password" class="kc_ajaxinput kc_ajaxwidth200" name="userpass" maxlength="30" value="'.(empty($_POST['userpass'])?'':$_POST['userpass']).'"/></td></tr>';
		if (kc_config('switch.checkcode')==1) {
		$s.='<tr><th>验证码：</th><td>'.$checkcode->show().'</td></tr>';
		}
		$oauthlogin_app=$db->getRows_one('%s_app','*',"path='oauthlogin'");
		if(!empty($oauthlogin_app))
		{
			$oauthlogins=$db->getRows('%s_oauthlogin','apiname,apicode',"enable=1");
			if (!empty($oauthlogins))
			{
				$s.='<tr><td colspan="2"><div class="kc_oauthlogin"><span>其他帐号：</span>';
				foreach($oauthlogins as $oauth){
					$s.='<a title="'.$oauth['apiname'].'" class="kc_oauthlogin'.$oauth['apicode'].'" onclick="window.location=\''.FULLURL.'apps/oauthlogin/api/'.$oauth['apicode'].'/login.php\';return false;" href="javascript:void(0)">'.$oauth['apiname'].'</a>';
				}
				$s.='</div></td></tr>';
			}	
		}
		$s.='</table>';
		
		kc_ajax(array(
			'TITLE'=>'用户登陆',
			'MAIN'=>$s,
			'ID'=>'kc_ajax',
			'WIDTH'=>380,
			'HEIGHT'=> empty($oauthlogins) ? 230 : 320,
			'BUTTON'=>'<button onclick="$.kc_ajax({URL:\''.FULLURL.'user/manage.php\',CMD:\'login\',FORM:\'kc_ajaxform\',METHOD:\'POST\'})">登陆</button>',
		));
	}
	$str=new str;
	$username=kc_post('username');
	$userpass=kc_post('userpass');
	if (empty($username)) kc_tip('会员名不能为空','form');
	if ($str->len($username)>12) kc_tip('会员名太长，不能超过12字','form');
	if(preg_match('/[\s\!\@\/\\\|\]\[\}\{\#\$\%\^\&\*\(\)\+\=\-]/',$username)) kc_tip('会员名不能含有非法字符!','form');
	if(empty($userpass)) kc_tip('密码不能为空','form');
	if (strlen($userpass)>20) kc_tip('您的密码太长，不能超过20个字符!','form');
	$uname=$db->encode($username);
	$config = kc_config('uc.config');
	$rememberme=intval(kc_post('remember'));
	$uc_setting = !empty($config) ? json_decode($config,true) : array();
	if(!empty($uc_setting) && $uc_setting['status'] == '1') {	//启用UC统一登录
		define('UC_CONNECT', $uc_setting['connect'] == 'mysql' ? 'mysql' : '');
		define('UC_DBHOST', isset($uc_setting['dbhost'])?$uc_setting['dbhost']:'');
		define('UC_DBUSER', isset($uc_setting['dbuser'])?$uc_setting['dbuser']:'');
		define('UC_DBPW', isset($uc_setting['dbpw'])?$uc_setting['dbpw']:'');
		define('UC_DBNAME', isset($uc_setting['dbname'])?$uc_setting['dbname']:'');
		define('UC_DBCHARSET', isset($uc_setting['dbcharset'])?$uc_setting['dbcharset']:'');
		define('UC_DBTABLEPRE', isset($uc_setting['dbtablepre'])?$uc_setting['dbtablepre']:'');
		define('UC_DBCONNECT', 0);
		define('UC_KEY', isset($uc_setting['key'])?$uc_setting['key']:'');
		define('UC_API', isset($uc_setting['api'])?$uc_setting['api']:'');
		define('UC_CHARSET', isset($uc_setting['charset'])?$uc_setting['charset']:'');
		define('UC_IP', isset($uc_setting['ip'])?$uc_setting['ip']:'');
		define('UC_APPID', isset($uc_setting['appid'])?$uc_setting['appid']:'');
		include_once(ROOT . 'uc_client/client.php');
		list($uc_uid, $uc_username, $uc_password, $uc_email) = uc_user_login($uname, $userpass);
		if($uc_uid > 0) {
			$rs=$db->getRows_one('%s_user','userid,userpass',"userid=$uc_uid");
			if (empty($rs)) {
				$upass=md5($userpass);
				$ip=$str->ip();
				$array=array(
					'userid'=>$uc_uid,
					'username'=>$uname,
					'userpass'=>$upass,
					'date'=>time(),
					'ip'=>$ip,
					'regip'=>$ip,
					'regdate'=>time(),
				);
				$db->insert('%s_user',$array);
				kc_log(array('userid'=>$uc_uid,'app'=>'user','action'=>'USER_LOGIN','cid'=>$uc_uid));
				kc_setCookie('userauth',md5($upass).$uc_uid,8640000);
				if($rememberme==1){
					kc_setCookie('userautologin',encrypt($uname.'|'.$uc_uid.'|'.$userpass),604800);
				}else{
					kc_setCookie('userautologin','',-604800);
				}
				$referer=kc_post('HTTP_REFERER');
				kc_ajax(array('JS'=>"go('$referer')"));
			}else{
				kc_log(array('userid'=>$rs['userid'],'app'=>'user','action'=>'USER_LOGIN','cid'=>$rs['userid']));
				kc_setCookie('userauth',md5($rs['userpass']).$rs['userid'],8640000);
				if($rememberme==1){
					kc_setCookie('userautologin',encrypt($uname.'|'.$rs['userid'].'|'.$userpass),604800);
				}else{
					kc_setCookie('userautologin','',-604800);
				}
				$referer=kc_post('HTTP_REFERER');
				kc_ajax(array('JS'=>"go('$referer')"));
			}
		}
	}	
	$upass=md5($userpass);
	$checkcode=new checkcode;$checkcode->check();
	$rs=$db->getRows_one('%s_user','userid',"username='$uname' and userpass='$upass'");
	if (empty($rs)) {
		kc_log(array('userid'=>0,'app'=>'user','action'=>'USER_LOGIN_ERROR'));
		kc_tip('帐号密码有误，登录失败！\n您是不是还没有注册成为会员？','form');
	}else{
		kc_log(array('userid'=>$rs['userid'],'app'=>'user','action'=>'USER_LOGIN','cid'=>$rs['userid']));
		kc_setCookie('userauth',md5($upass).$rs['userid'],8640000);
		if($rememberme==1){
			kc_setCookie('userautologin',encrypt($uname.'|'.$rs['userid'].'|'.$userpass),604800);
		}else{
			kc_setCookie('userautologin','',-604800);
		}
		$referer=kc_post('HTTP_REFERER');
		kc_ajax(array('JS'=>"go('$referer')"));
	}
}
//退出登陆
function _logout(){
	$u=new user;
	kc_log(array('userid'=>$u->info['userid'],'app'=>'user','action'=>'USER_LOGOUT','cid'=>$u->info['userid']));
	kc_setCookie('userauth','',-864000);
	kc_ajax(array('JS'=>"go('".FULLURL."')"));
}
//注册
function _register(){
	$u=new user;
	extract($u->info);
	if(kc_config('switch.user')==0) kc_tip('本站用户注册功能已关闭，请和管理员联系直接开通用户，谢谢！');
	if($islogin) kc_tip('您已经登录，注册帐号失败!');
	$username=kc_post('username');
	$userpass=kc_post('userpass');
	$userpass1=kc_post('userpass1');
	$email=kc_post('email');
	$name=kc_post('name');
	$phone=kc_post('phone');
	$tel=kc_post('tel');
	$db=new db;
	$uname=$db->encode($username);
	$rs=$db->getRows_one('%s_user','userid',"username='$uname'");
	if(!empty($rs)) kc_ajax(array('JS'=>'alert(\'会员名 '.$username.' 已被注册，请换其他名称!\')'));
    $str=new str;
	if(METHOD=='POST'){
		if(empty($username)) kc_tip('会员名不能为空!','form');
		if ($str->len($username)<3) kc_tip('会员名太短，不能少于3字!','form');
		if ($str->len($username)>12) kc_tip('会员名太长，不能超过12字!','form');
		if(preg_match('/[\s\!\@\/\\\|\]\[\}\{\#\$\%\^\&\*\(\)\_\+\=\-]/',$username)) kc_tip('会员名不能含有非法字符!','form');
		if(empty($userpass)) kc_tip('密码不能为空!','form');
		if (strlen($userpass)>30) kc_tip('您的密码太长，不能超过30个字符!','form');
		if($userpass1<>$userpass) kc_tip('两次输入的密码不一致!','form');
		if(!empty($email) && !kc_validate($email,5)) kc_tip('电子邮箱格式错误!','form');
		if(!empty($phone) && !kc_validate($phone,35)) kc_tip('手机号码格式错误!','form');
		if(kc_config('switch.regemail')==1){
			$email_captcha=kc_post('email_captcha');
			$email_captcha_id=intval(kc_post('email_captcha_id'));
			if(empty($email_captcha)) kc_tip('邮箱验证码不能为空!','form');
			$md5word = md5($email_captcha);
			$ea_info=$db->getRows_one('%s_email_activate','activation',"email='$email' AND ae_id='$email_captcha_id'");
			if($ea_info['activation'] != $md5word) kc_tip('邮箱验证码错误!','form');
		}
		if(kc_config('switch.regphone')==1){
			$sms_captcha=kc_post('sms_captcha');
			$sms_captcha_id=intval(kc_post('sms_captcha_id'));
			if(empty($sms_captcha)) kc_tip('手机验证码不能为空!','form');
			$sc_info=$db->getRows_one('%s_sms_captcha','end_time',"phone='$phone' and captcha='$sms_captcha' and id='$sms_captcha_id'");
			if(empty($sc_info)) kc_tip('邮箱验证码错误!','form');
			if($sc_info['end_time'] < time()) kc_tip('邮箱验证码已失效，请重新获取!','form');
		}
		$checkcode=new checkcode;
		$checkcode->check();//验证码验证
		$config = kc_config('uc.config');
		$uc_setting = !empty($config) ? json_decode($config,true) : array();
		if(!empty($uc_setting) && $uc_setting['status'] == '1') {	//启用UC统一登录
			define('UC_CONNECT', $uc_setting['connect'] == 'mysql' ? 'mysql' : '');
			define('UC_DBHOST', isset($uc_setting['dbhost'])?$uc_setting['dbhost']:'');
			define('UC_DBUSER', isset($uc_setting['dbuser'])?$uc_setting['dbuser']:'');
			define('UC_DBPW', isset($uc_setting['dbpw'])?$uc_setting['dbpw']:'');
			define('UC_DBNAME', isset($uc_setting['dbname'])?$uc_setting['dbname']:'');
			define('UC_DBCHARSET', isset($uc_setting['dbcharset'])?$uc_setting['dbcharset']:'');
			define('UC_DBTABLEPRE', isset($uc_setting['dbtablepre'])?$uc_setting['dbtablepre']:'');
			define('UC_DBCONNECT', 0);
			define('UC_KEY', isset($uc_setting['key'])?$uc_setting['key']:'');
			define('UC_API', isset($uc_setting['api'])?$uc_setting['api']:'');
			define('UC_CHARSET', isset($uc_setting['charset'])?$uc_setting['charset']:'');
			define('UC_IP', isset($uc_setting['ip'])?$uc_setting['ip']:'');
			define('UC_APPID', isset($uc_setting['appid'])?$uc_setting['appid']:'');
			include_once(ROOT . 'uc_client/client.php');
			$email = !empty($email) ? $email : date('YmdHis').'@'.SITEURL;
			$uc_uid = uc_user_register($username , $userpass , $email);
			if($uc_uid > 0) {
				$db=new db;
				$rs=$db->getRows_one('%s_user','userid',"userid='$uc_uid'");
				if (empty($rs)) {
					$upass=md5(($userpass));
					$ip=$str->ip();
					$array=array(
						'userid'=>$uc_uid,
						'username'=>$username,
						'userpass'=>$upass,
						'email'=>$email,
						'mobile'=>$phone,
						'date'=>time(),
						'ip'=>$ip,
						'regip'=>$ip,
						'regdate'=>time(),
					);
					$db->insert('%s_user',$array);
					kc_log(array('userid'=>$uc_uid,'app'=>'user','action'=>'USER_LOGIN','cid'=>$uc_uid));
					kc_setCookie('userauth',md5($upass).$uc_uid,8640000);
					$u->setPoint('user','register',$uc_uid,'会员注册','系统');
					$u->sendsms($uc_uid,'register');
					$referer=kc_post('HTTP_REFERER');
					kc_ajax(array('JS'=>"go('$referer')"));
				}
			}
		}		
		$upass=md5(($userpass));
		$ip=$str->ip();
		$array=array(
			'username'=>$username,
			'userpass'=>$upass,
			'name'=>$name,
			'date'=>time(),
			'ip'=>$ip,
			'regip'=>$ip,
			'regdate'=>time(),
		);
		if(!empty($email)) $array['email'] = $email;
		if(!empty($phone)) $array['mobile'] = $phone;
		$userid=$db->insert('%s_user',$array);		
		kc_log(array('userid'=>$userid,'app'=>'user','action'=>'USER_REGISTER','cid'=>$userid));
		kc_setCookie('userauth',md5($upass).$userid,8640000);
		$u->setPoint('user','register',$userid,'会员注册','系统');
		$u->sendsms($userid,'register');
		$array=array(
			'userid'=>$userid,
			'gid'=>1,
			'removedate'=>0,
		);
		$db->insert('%s_user_group_bind',$array);	
		
		$referer=kc_post('HTTP_REFERER');
		kc_ajax(array('JS'=>"go('$referer')"));
	}	
	if (METHOD=='GET') {
		$checkcode=new checkcode;
		$s='<table>';
		$s.='<tr><th>会员名：</th><td><input type="text" class="kc_ajaxinput kc_ajaxwidth200" name="username" maxlength="12" value="'.$username.'"/></td></tr>';
		$s.='<tr><th>密码：</th><td><input type="password" class="kc_ajaxinput kc_ajaxwidth200" name="userpass" maxlength="30" value="'.$userpass.'"/></td></tr>';
		$s.='<tr><th>确认密码：</th><td><input type="password" class="kc_ajaxinput kc_ajaxwidth200" name="userpass1" maxlength="30"/></td></tr>';
		if (kc_config('switch.checkcode')==1) {
			$s.='<tr><th>验证码：</th><td>'.$checkcode->show().'</td>';
		}
		$s.'</table>';
		kc_ajax(array(
			'TITLE'=>'新用户注册',
			'MAIN'=>$s,
			'ID'=>'kc_ajax',
			'WIDTH'=>370,
			'HEIGHT'=>270,
			'BUTTON'=>'<button onclick="$.kc_ajax({URL:\''.FULLURL.'user/manage.php\',CMD:\'register\',FORM:\'kc_ajaxform\',METHOD:\'POST\'})">确定注册</button>',
		));
	}
}
//找回密码
function _findpass(){
	$username=kc_post('username');
	$find_type=kc_post('find_type');

	if(empty($username)) kc_tip('请填写会员名!','form');
	$checkcode=new checkcode;$checkcode->check();
	$db=new db;
	if($find_type=='find_quest'){
		$quest_q=kc_post('quest_q');
		if(empty($quest_q)) kc_tip('请填写安全提问!','form');
		$quest_a=kc_post('quest_a');
		if(empty($quest_a)) kc_tip('请填写安全提问的答案!','form');
		$rs=$db->getRows_one('%s_user_security','userid',"sq='$quest_q' AND sqa='$quest_a'");
		if(empty($rs)) kc_tip('您提交的答案不正确!','form');	
		$new_password=kc_post('new_password');
		if(empty($new_password)) kc_tip('请填写新密码!','form');
		$confirm_password=kc_post('confirm_password');
		if(empty($confirm_password)) kc_tip('请填写确认密码!','form');
		if($new_password != $confirm_password) kc_tip('两次输入的密码不一致!','form');
		
		$db->update('%s_user',array('userpass'=>md5($new_password)),'userid='.$rs['userid']);
		kc_tip('您的密码设置成功！','ok');		
	}elseif($find_type=='find_email'){
		if(kc_checkApp('email')){
			$email=kc_post('email');
			if(empty($email)) kc_tip('请填写已绑定的邮箱!','form');
			$rs=$db->getRows_one('%s_user','userid',"username='$username' AND email='$email'");
			if(empty($rs)) kc_tip('您填写的会员名与电子邮箱不匹配，请重新输入!','form');
			$email_captcha=kc_post('email_captcha');
			if(empty($email_captcha)) kc_tip('请填写邮箱验证码!','form');
			$email_captcha_id=intval(kc_post('email_captcha_id'));
			$md5word = md5($email_captcha);
			$ea_info=$db->getRows_one('%s_email_activate','activation',"email='$email' AND ae_id='$email_captcha_id'");
			if($ea_info['activation'] != $md5word) kc_tip('邮箱验证码错误!','form');
			$new_password=kc_post('new_password');
			if(empty($new_password)) kc_tip('请填写新密码!','form');
			$confirm_password=kc_post('confirm_password');
			if(empty($confirm_password)) kc_tip('请填写确认密码!','form');
			if($new_password != $confirm_password) kc_tip('两次输入的密码不一致!','form');
			$db->update('%s_user',array('userpass'=>md5($new_password)),'userid='.$rs['userid']);
			kc_tip('您的密码设置成功！','ok');
		}else{
			kc_tip('[邮件助手]应用未安装，请与管理员联系!','form');
		}
	}else{
		if(kc_checkApp('sms')){
			$phone=kc_post('phone');
			if(empty($phone)) kc_tip('请填写已绑定的手机号码!','form');
			$rs=$db->getRows_one('%s_user','userid',"username='$username' AND mobile='$phone'");
			if(empty($rs)) kc_tip('您填写的会员名与手机号码不匹配，请重新输入!','form');
			$sms_captcha=kc_post('sms_captcha');
			$sms_captcha_id=intval(kc_post('sms_captcha_id'));
			if(empty($sms_captcha)) kc_tip('手机验证码不能为空!','form');
			$sc_info=$db->getRows_one('%s_sms_captcha','end_time',"phone='$phone' and captcha='$sms_captcha' and id='$sms_captcha_id'");
			if(empty($sc_info)) kc_tip('手机验证码错误!','form');
			if($sc_info['end_time'] < time()) kc_tip('手机验证码已失效，请重新获取!','form');
			$new_password=kc_post('new_password');
			if(empty($new_password)) kc_tip('请填写新密码!','form');
			$confirm_password=kc_post('confirm_password');
			if(empty($confirm_password)) kc_tip('请填写确认密码!','form');
			if($new_password != $confirm_password) kc_tip('两次输入的密码不一致!','form');
			
			$db->update('%s_user',array('userpass'=>md5($new_password)),'userid='.$rs['userid']);
			kc_tip('您的密码设置成功！','ok');	
		}else{
			kc_tip('[短信通]应用未安装，请与管理员联系!','form');
		}
	}

}
//[自己]重设密码
function _updatepass(){
	$u=new user;
	extract($u->info);
	if ($userid) {
		if (METHOD=='POST') {//提交状态的时候进行判断
			$oldpass=kc_post('oldpass');
			$newpass1=kc_post('newpass1');
			$newpass2=kc_post('newpass2');
			if(empty($oldpass)) kc_ajax(array('JS'=>'alert(\'原始密码不能为空!\')'));
			if(empty($newpass1)) kc_ajax(array('JS'=>'alert(\'新密码不能为空!\')'));
			if(empty($newpass2)) kc_ajax(array('JS'=>'alert(\'确认新密码不能为空!\')'));
			if($newpass1 != $newpass2) kc_ajax(array('JS'=>'alert(\'两次输入的密码不一致!\')'));
			$db=new db;
			$rs=$db->getRows_one('%s_user','userpass','userid='.$userid);
			if ($rs['userpass']!=md5(kc_post('oldpass'))) {
				kc_tip('您的密码有误!','form');
			}
			$md5pass=md5($newpass1);
			$db->update('%s_user',array('userpass'=>$md5pass),'userid='.$userid);
			kc_log(array('userid'=>$userid,'app'=>'user','action'=>'USER_UPDATEPASS','cid'=>$userid));
			kc_setCookie('userauth',md5($md5pass).$userid,8640000);
			kc_tip('成功修改您的密码为新的密码!','ok', array('返回帐户中心'=>'/?user-security'));
		}
		$s='<table>';
		$s.='<tr><th>原密码：</th><td><input type="password" name="oldpass" class="kc_ajaxinput kc_ajaxwidth150" maxlength="20"/></td></tr>';
		$s.='<tr><th>新密码：</th><td><input type="password" name="newpass1" class="kc_ajaxinput kc_ajaxwidth150" maxlength="20"/></td></tr>';
		$s.='<tr><th>确认密码：</th><td><input type="password" name="newpass2" class="kc_ajaxinput kc_ajaxwidth150" maxlength="20"/></td></tr>';
		$s.='</table>';
		
		kc_ajax(array(
			'TITLE'=>'修改密码',
			'MAIN'=>$s,
			'ID'=>'kc_ajax',
			'WIDTH'=>370,
			'HEIGHT'=>245,
			'BUTTON'=>'<button onclick="$.kc_ajax({URL:\''.FULLURL.'user/manage.php\',CMD:\'updatepass\',FORM:\'kc_ajaxform\',METHOD:\'POST\'})">修改</button>',
		));
	}else{
		kc_tip('请先登录，或注册成为会员！');
	}
}
//删除会员
function _delete(){
	$u=new user;
	$u->auth_role('admin');
	$userid=kc_post('userid',2,1);
	if($u->info['userid']==$userid) kc_tip('不能删除自己!');
	$db=new db;
	$db->delete('%s_user','userid='.$userid);
	$db->delete('%s_user_security','userid='.$userid);//同时删除会员的安全帐户信息
	$db->delete('%s_user_pm','puserid='.$userid);//同时删除会员的站内信息	
	kc_log(array('userid'=>$u->info['userid'],'app'=>'user','action'=>'USER_DELETE','cid'=>$userid));
	kc_tip('删除成功!','ok','refresh');
}
//管理员重命名会员名
function _rename(){
	$u=new user;
	$u->auth_role('admin');
	$userid=kc_post('userid',2,1);
	$db=new db;
	$rs=$db->getRows_one('%s_user','username','userid='.$userid);
	if(empty($rs)) kc_tip('会员名记录已丢失!');
	$str=new str;
	if(empty($_POST['username'])) kc_tip('请填写会员名!','form');
	if($_POST['username']==$rs['username']) kc_tip('新的会员名不能和旧会员名一致!','form');
	if ($str->len($_POST['username'])>12) kc_tip('会员名太长，不能超过12字','form');
	if(preg_match('/[<>\s\!\@\/\\\|\]\[\}\{\#\$\%\^\&\*\(\)\_\+\=\-]/',$_POST['username'])) kc_tip('会员名不能含有非法字符!','form');
	$uname=$db->encode($_POST['username']);
	if($db->getRows_one('%s_user','userid',"username='$uname' and userid<>$userid")) kc_tip('当前会员名已经存在!','form');
	$array=array('username'=>$_POST['username']);
	$db->update('%s_user',$array,'userid='.$userid);
	$js="\$.kc_close();alert('成功修改会员名[{$rs['username']}]为[{$_POST['username']}]!');$('#form_publish [name=\"username\"]').val('{$_POST['username']}');";
	kc_log(array('userid'=>$u->info['userid'],'app'=>'user','action'=>'USER_RENAME','cid'=>$userid));
	kc_ajax(array('JS'=>$js));
}
//管理员新建/编辑用户信息
function _edit(){
	$u=new user;
	$u->auth_role('user_edit',false,true);
	$userid=kc_post('userid',2,0);

	$db=new db;
	$str=new str;
	if(empty($userid)){
		if (empty($_POST['username'])) kc_tip('请填写会员名!','form');
		if ($str->len($_POST['username'])>12) kc_tip('会员名太长，不能超过12字','form');
		if(preg_match('/[<>\s\!\@\/\\\|\]\[\}\{\#\$\%\^\&\*\(\)\_\+\=\-]/',$_POST['username'])) kc_tip('会员名不能含有非法字符!','form');
		$rs=$db->getRows_one('%s_user','userid','username=\''.$db->encode($_POST['username']).'\'');
		if(!empty($rs)) kc_tip('您要添加的用户已经存在!','form');
	}
	if(empty($userid)){
		if(empty($_POST['userpass'])) kc_tip('密码不能为空!','form');
	}
	if(!empty($_POST['username'])){
		if (strlen($_POST['userpass'])>30) kc_tip('您的密码太长，不能超过30个字符!','form');
		if($_POST['userpass1']<>$_POST['userpass']) kc_tip('两次输入的密码不一致!','form');
	}	
	if(!empty($_POST['rid']) && !kc_validate($_POST['rid'],3)) kc_tip('所属角色参数错误!','form');
	$rids=empty($_POST['rid']) ? array() : explode(',',$_POST['rid']);
	foreach($rids as $rid){
		if(!empty($_POST['role_removedate'.$rid]) && !kc_validate($_POST['role_removedate'.$rid],9)) kc_tip('有效日期格式不正确!','form');
	}	
	if(!empty($_POST['gid']) && !kc_validate($_POST['gid'],3)) kc_tip('所属用户组参数错误!','form');
	$gids=empty($_POST['gid']) ? array() : explode(',',$_POST['gid']);
	foreach($gids as $gid){
		if(!empty($_POST['group_removedate'.$gid]) && !kc_validate($_POST['group_removedate'.$gid],9)) kc_tip('有效日期格式不正确!','form');
	}
	if($str->len($_POST['name'])>20) kc_tip('真实姓名过长!','form');
	if($str->len($_POST['tel'])>30) kc_tip('电话过长!','form');
	if($str->len($_POST['email'])>50) kc_tip('邮箱过长!','form');
	if(!empty($_POST['email']) && !kc_validate($_POST['email'],5)) kc_tip('邮箱地址格式','form');
	if($str->len($_POST['qq'])>12) kc_tip('QQ号码过长!','form');
	if($str->len($_POST['address'])>200) kc_tip('详细地址过长!','form');
	if($str->len($_POST['qianming'])>250) kc_tip('个性签名过长!','form');	
	$array=array(
		'name'=>$_POST['name'],
		'tel'=>$_POST['tel'],
		'mobile'=>$_POST['mobile'],
		'email'=>$_POST['email'],
		'qq'=>$_POST['qq'],
		'address'=>$_POST['address'],
		'qianming'=>$_POST['qianming'],		
	);	
	if(!empty($_POST['userpass'])) $array['userpass']=md5($_POST['userpass']);
	if(empty($userid)){
		$array['username']=$_POST['username'];
		$array['regdate']=TIME;
		$array['date']=TIME;
		$array['regip']=$str->ip();
		$array['ip']=$str->ip();
		$userid=$db->insert('%s_user',$array);
		kc_log(array('userid'=>$u->info['userid'],'app'=>'user','action'=>'USER_NEW','cid'=>$userid));
	}else{
		$db->update('%s_user',$array,'userid='.$userid);
		$db->delete('%s_user_group_bind','userid='.$userid);
		$db->delete('%s_user_role_bind','userid='.$userid);
		kc_log(array('userid'=>$u->info['userid'],'app'=>'user','action'=>'USER_EDIT','cid'=>$userid));
	}	
	//更新role和user绑定表信息
	$array=array();
	foreach($rids as $rid){
		$removedate=empty($_POST['role_removedate'.$rid]) ? 0 :str_replace('-','',$_POST['role_removedate'.$rid]);
		$array[]=array(
			'userid'=>$userid,
			'rid'=>$rid,
			'removedate'=>$removedate,
		);
	}
	$db->insert('%s_user_role_bind',$array,1);	
	//更新group和user绑定表信息
	$array=array();
	foreach($gids as $gid){
		$removedate=empty($_POST['group_removedate'.$gid]) ? 0 :str_replace('-','',$_POST['group_removedate'.$gid]);
		$array[]=array(
			'userid'=>$userid,
			'gid'=>$gid,
			'removedate'=>$removedate,
		);
	}
	$db->insert('%s_user_group_bind',$array,1);	
	kc_ajax(array('JS'=>"go('/?_=user')"));
}
function _deleteavatar(){
	$u=new user;
	$u->auth_role('admin');
	$id=kc_post('userid',2,1);
	$dir=round($id/10000);//大目录
	$file=new file;
	$file->delete(PATH_UP.'/user/'.$dir.'/'.substr($id,-4).'_48.gif');
	$file->delete(PATH_UP.'/user/'.$dir.'/'.substr($id,-4).'_100.gif');
	$referer=kc_post('HTTP_REFERER');
	kc_ajax(array('JS'=>"go('$referer')"));
}
//刷新缓存
function _clearcache(){
	$u=new user;
	$u->auth_role('user_cache');
	$file=new file;
	$file->rd(PATH_CACHE);	
	kc_tip('刷新缓存成功!','ok');
}
//会员签到
function _dailycheck(){
	$u=new user;
	if(!$u->info['islogin']) kc_tip('请先登录!');
	$db=new db;	
	if(!empty($u->info['dailycheck'])) kc_ajax(array('JS'=>"alert('您已经签过到了！');"));;
	$action=$u->getPointAction('user','dailycheck');	
	$js='';
	if(!empty($action)){
		$u->setPoint('user', 'dailycheck',null,'会员签到','系统');
		$msg='您已经成功签到。';
		$msg.='\n';
		foreach($action as $r){
			$msg.='【'.$r['pointname'].':'.$r['value'].'】';
		}
		$js="alert('$msg');";
	}
	$js.="\$('#dailycheck').remove();";
	$db->update('%s_user',array('dailycheck'=>1),'userid='.$u->id);
	kc_ajax(array('JS'=>$js));
}
//生成授权文件
function _createlicense(){
	$produceid=kc_post('produceid',2,1);
	if(!$produceid) kc_tip('请先填写产品编号!', 'form');
	$domain_name=kc_post('domain_name');
	if(!$domain_name) kc_tip('请先填写域名!', 'form');
	$ip=kc_post('ip');
	if(!$ip) kc_tip('请先填写IP!', 'form');
	$db=new db;
	$license=$db->getRows_one('%s_user_license','domain_name',"produceid='$produceid' AND ip='$ip' and domain_name='$domain_name'");
	if(empty($license)){
		$array['produceid']=$produceid;
		$array['domain_name']=$domain_name;
		$array['add_time']=time();
		$array['ip']=$ip;
		$db->insert('%s_user_license', $array);
		$license_str = MD5(LICENSE_KEY . $ip . $domain_name . $produceid);	
		header("Content-type: application/octet-stream");
		header("Accept-Ranges: bytes");
		header("Accept-Length: " . strlen($license_str));
		header("Content-Disposition: attachment; filename=license.lock");
		echo $license_str;
	}else{
		kc_tip('该授权信息已存在!', 'form');
	}	
}
//添加模板LOGO
function _tplogoedt(){
	$u=new user;
	$u->auth_role('admin');
	$db=new db;
	$str=new str;
	$id=kc_post('id',2);
	$path=kc_post('path',0,1);
	$prod=kc_post('prod',0,1);
	$code=kc_post('code');
	$logourl=kc_post('logourl');
	$size = '';
	$note = '';
	$data=array('image'=>'');
	$config_file = ROOT.'/templates/'.$path.'/logoconfig.php';
	if(!file_exists($config_file)) kc_tip('该模板的Logo配置文件不存在，请先创建该文件!');
	$config=require $config_file;
	if (METHOD=='GET') {
		//添加的时候初始化数据
		if (empty($id)) {
			#TODO
		}else{
			$data=$db->getRows_one('%s_template_logo','*','id='.$id);
			$code=$data['code'];
			$size = $config[$code]['size'];
			$note = $config[$code]['note'];
		}
	}elseif(METHOD=='POST'){
		$image=kc_post('image',2,1);
		$title=kc_post('title');
		if(empty($image)) kc_ajax(array('JS'=>'alert(\'请先上传LOGO图片!\')'));
		if(!kc_validate($code,'/^[a-zA-Z0-9]+$/')) kc_ajax(array('JS'=>'alert(\'LOGO图片代码格式必须为字母和数字构成!\')'));
		$rs=$db->getRows_one('%s_up_image','*','image='.$image);
		$array=array(
			'path'=>$path,
			'prod'=>$prod,
			'title'=>$title,
			'code'=>$code,
			'image'=>$image,
			'logopath'=>PATH_UP.'/'.$rs['path'],
			'logourl'=>$logourl,
		);
		if (empty($id)) {
			$db->insert('%s_template_logo', $array);
		}else{
			$db->update('%s_template_logo',$array,'id='.$id);
		}
		$referer=kc_post('HTTP_REFERER');
		kc_ajax(array('JS'=>"go('$referer')"));
	}
	$js="\$('select[name=\"code\"]').change(function(){var kctype=\$(this).find('option:selected').attr('kctype');var kctypes = kctype.split('|');\$('#size').html(kctypes[0]);\$('#note').html(kctypes[1]);\$('#title').val(kctypes[2]);});";
	$s='<table>';
	$s.='<tr><th>图片名称：</th><td><select class="downselect" name="code">';
	foreach($config as $key=>$r){
		if(empty($size)) $size = $r['size'];
		if(empty($note)) $note = $r['note'];
		if(empty($code)) $code = $key;
		$s.='<option kctype="'.$r['size'].'|'.$r['note'].'|'.$r['title'].'" value="'.$key.'"'.($key==$code ? ' selected="true"' : '').'>'.$key.'</option>';
	}
	$s.='</select></td></tr>';
	$s.='<tr><th>图片大小：</th><td id="size">'.$size.'</td></tr>';
	$s.='<tr><th>图片描述：</th><td id="note">'.$note.'</td></tr>';
	$s.='<tr><th>图片上传：</th><td><input name="title" id="title" value="'.$config[$code]['title'].'" type="hidden"/><p class="uploadfile"><iframe src="'.FULLURL.'user/up_image.php?CMD=button&id=up_image" frameborder="0" class="iframe_up" scrolling="no"></iframe>上传图片</p><input name="image" id="up_image" value="'.$data['image'].'" type="text" maxlength="10" class="kc_ajaxinput kc_ajaxwidth70" style="margin-left:10px;"/></td></tr>';
	$s.='<tr><th>链接地址：</th><td id="url"><input name="logourl" value="'.$data['logourl'].'" type="text" class="kc_ajaxinput kc_ajaxwidth200"/><em class="kc_ajaxlabel">图片链接，内链相对链接，示例：/news<br />外链绝对链接，示例：http://www.kingcms.com/</em></td></tr>';
	$s.='</table>';
	kc_ajax(array(
		'TITLE'=>empty($id)?'添加LOGO图片':'编辑LOGO图片',
		'MAIN'=>$s,
		'ID'=>'kc_ajax',
		'WIDTH'=>450,
		'HEIGHT'=>355,
		'BUTTON'=>'<button onclick="$.kc_ajax({URL:\''.FULLURL.'user/manage.php\',CMD:\'tplogoedt\',FORM:\'kc_ajaxform\',METHOD:\'POST\',id:\''.$id.'\',prod:\''.$prod.'\',path:\''.$path.'\'})">保存</button>',
		'JS'=>$js,
	));
}
//删除模板LOGO
function _deletetplogo(){
	$id=kc_get('id',3,1);
	if(empty($id)) kc_tip('请选择至少一个要删除的Logo文件!');
	$db=new db;
	$image = array();
	$res=$db->getRows('%s_template_logo','image',"id in ($id)");
	if(!empty($res)){
		foreach($res as $rs){
			$image[] = $rs['image'];
		}
		$db->delete('%s_template_logo',"id in ($id)");
	}
	if(!empty($image)){
		$images = implode(',', $image);	
		$file=new file;
		$res=$db->getRows('%s_up_image','path',"image in ($images)");
		foreach($res as $rs){
			$file->delete(PATH_UP.'/'.$rs['path']);
		}
		$db->delete('%s_up_image',"image in ($images)");
	}	
	kc_ajax(array('JS'=>"go('{$_POST['HTTP_REFERER']}');"));
}
//编辑或验证电子邮箱
function _email(){
	$u=new user;
	extract($u->info);
	if ($userid) {
		if (METHOD=='POST') {//提交状态的时候进行判断
			$bind=intval(kc_post('bind'));
			$email=kc_post('email');
			if(empty($email)) kc_tip('电子邮箱不能为空!','form');
			if(!kc_validate($email,5)) kc_tip('电子邮箱格式错误!','form');
			if($bind>0){
				kc_tip('成功修改您的电子邮箱!','ok');
			}else{
				$db->update('%s_user',array('email'=>$email),'userid='.$userid);
				kc_tip('成功修改您的电子邮箱!','ok');
			}			
		}
	}else{
		kc_tip('请先登录，或注册成为会员！');
	}
}
//测试邮件
function _test_email(){
	$u=new user;
	$u->auth_role('admin');
	$db=new db;
	$email_from = kc_config('site.name');
    $email_type = $_POST['email_type'];
    $email_host = $_POST['email_host'];
    $email_port = $_POST['email_port'];
    $email_addr = $_POST['email_addr'];
    $email_id   = $_POST['email_id'];
    $email_pass = $_POST['email_pass'];
    $email_test = $_POST['email_test'];
    $email_subject = '测试邮件';
    $email_content = '这是一封测试邮件，证明您的邮件已经设置成功';
	$mailer=new mailer;
	kc_ajax(array('JS'=>"\$.kc_close();alert('成功更新邮件设置!');\$('.Submit').removeAttr('disabled');"));
}
//安全警告提示信息
function _getwarning(){
	$u=new user;
	if(!$u->isAdmin()) kc_ajax(array('JS'=>'您不是管理员，不能调用该接口！'));
	$file=new file;
	$js='';
	$html='';
	if(is_dir(ROOT.'install')) {
		$html.="<div class=\"warning\"><p>install 安装目录没有及时删除，您的网站存在安全隐患。</p></div>";
	}	
	$filename=$file->encode('upfiles/lm.php',1);
	if(file_put_contents(ROOT.$filename,'',LOCK_EX) === false ){
		$html.="<div class=\"warning\"><p>upfiles 目录不可写入，您将无法上传图片文件。</p></div>";
	}else{
		if(file_exists(ROOT.$filename)) unlink(ROOT.$filename);
	}
	$js.="\$('#main>.notice').after('{$html}');";
	kc_ajax(array('JS'=>$js));
}
//获取服务器信息
function _getsysinfo(){
	$u=new user;
	if(!$u->isAdmin()) kc_ajax(array('JS'=>'您不是管理员，不能调用该接口！'));
	$db=new db;
	$js='';
	$html='';
	if(PHP_OS){
		$html.='<p><strong>操作系统：</strong><span>'.PHP_OS.'</span></p>';
	}else{
		$html.='<p><strong>操作系统：</strong><span>未知</span></p>';
	}
	if(!empty($_SERVER['SERVER_SOFTWARE'])){
		$html.='<p><strong>WEB服务器：</strong><span>'.$_SERVER['SERVER_SOFTWARE'].'</span></p>';
	}else{
		$html.='<p><strong>WEB服务器：</strong><span>未知</span></p>';
	}
	if(PHP_VERSION){
		$html.='<p><strong>PHP版本：</strong><span>'.PHP_VERSION.'</span></p>';
	}else{
		$html.='<p><strong>PHP版本：</strong><span>未知</span></p>';
	}
	$mysqlversion=$db->version();
	if(!empty($mysqlversion)){
		$html.='<p><strong>MySQL版本：</strong><span>'.$mysqlversion.'</span></p>';
	}else{
		$html.='<p><strong>MySQL版本：</strong><span>未知</span></p>';
	}
	$js.="\$('div.sysinfo').html('{$html}');";
	kc_ajax(array('JS'=>$js));
}
//帐户安全-设置安全问题
function _setsq(){
	$u=new user;
	extract($u->info);
	if ($userid) {
		if (METHOD=='POST') {//提交状态的时候进行判断
			$db=new db;
			$sq=kc_post('sq');
			$sqa=kc_post('sqa');
			$old_sqa=kc_post('old_sqa');
			$rs=$db->getRows_one('%s_user_security','sq,sqa','userid='.$userid);
			if(!empty($rs['sq']) && empty($old_sqa)) kc_tip('原答案不能为空!','form');
			if(!empty($rs['sqa']) && ($rs['sqa']!=$old_sqa))  kc_tip('原答案不正确!','form');
			if(empty($sq)) kc_tip('安全问题不能为空!','form');
			if(empty($sqa)) kc_tip('问题答案不能为空!','form');

			if (empty($rs)) {
				$array=array(
					'userid'=>$userid,
					'sq'=>$sq,
					'sqa'=>$sqa
				);
				$db->insert('%s_user_security',$array);
			} else {
				$db->update('%s_user_security',array('sq'=>$sq,'sqa'=>$sqa),'userid='.$userid);
			}
			kc_tip('成功设置您的安全问题!','ok', array('返回帐户中心'=>'/?user-security'));
		}
	}else{
		kc_tip('请先登录，或注册成为会员！','form');
	}
}
//帐户安全-编辑安全问题
function _editqa(){
	$u=new user;
	extract($u->info);
	if ($userid) {
		if (METHOD=='POST') {//提交状态的时候进行判断
			$sqa=kc_post('sqa');
			$referer=kc_post('HTTP_REFERER');
			if(empty($sqa)) kc_tip('安全密码不能为空!','form');
			$db=new db;
			$rs=$db->getRows_one('%s_user_security','userid',"sqa='{$sqa}' AND userid={$userid}");
			if (empty($rs)) {
				kc_tip('安全密码不正确!','form');
			}else{
				if($referer) kc_ajax(array('JS'=>"go('$referer')"));
				else kc_ajax(array('JS'=>"go('/?user-security_qa');"));
			}
		}
		$referer=kc_post('HTTP_REFERER');
		$db=new db;
		$rs=$db->getRows_one('%s_user_security','sq','userid='.$userid);
		if (!empty($rs['sq'])) {
			$s='<table>';
			$s.='<tr><th>安全问题：</th><td>'.$rs['sq'].'</td></tr>';
			$s.='<tr><th>安全密码：</th><td>';
			$s.='<input type="text" class="kc_ajaxinput kc_ajaxwidth200" name="sqa" maxlength="30" value=""/></td></tr>';
			$s.='</table>';
			kc_ajax(array(
				'TITLE'=>'确认安全密码',
				'MAIN'=>$s,
				'ID'=>'kc_ajax',
				'WIDTH'=>380,
				'HEIGHT'=>230,
				'BUTTON'=>'<button onclick="$.kc_ajax({URL:\''.FULLURL.'user/manage.php\',CMD:\'editqa\',FORM:\'kc_ajaxform\',METHOD:\'POST\',HTTP_REFERER:\''.$referer.'\'})">提交</button>',
			));
		} else {
			kc_ajax(array('JS'=>"go('/?user-security_qa');"));
		}
	}else{
		kc_tip('请先登录，或注册成为会员！','form');
	}
}
//帐户安全-个人认证
function _personverify(){
	$u=new user;
	extract($u->info);
	if ($userid) {
		if (METHOD=='POST') {//提交状态的时候进行判断
			$realname=kc_post('realname');
			if(empty($realname)) kc_tip('真实姓名不能为空!','form');
			$id_card=kc_post('id_card');
			if(empty($id_card)) kc_tip('身份证号码不能为空!','form');
			$card_front=kc_post('card_front');
			if(empty($card_front)) kc_tip('安全问题不能为空!','form');
			$card_back=kc_post('card_back');
			if(empty($card_back)) kc_tip('问题答案不能为空!','form');
			$db=new db;
			$rs=$db->getRows_one('%s_user_security','userid','userid='.$userid);
			if (empty($rs)) {
				$array=array(
					'userid'=>$userid,
					'realname'=>$realname,
					'id_card'=>$id_card,
					'card_front'=>$card_front,
					'card_back'=>$card_back,
					'personverify'=>1
				);
				$db->insert('%s_user_security',$array);
			} else {
				$db->update('%s_user_security',array('realname'=>$realname,'id_card'=>$id_card,'card_front'=>$card_front,'card_back'=>$card_back,'personverify'=>1),'userid='.$userid);
			}
			kc_tip('成功提交您的个人认证，请等待管理员审核!','ok', array('返回帐户中心'=>'/?user-security'));			
		}
	}else{
		kc_tip('请先登录，或注册成为会员！','form');
	}
}
//帐户安全-企业认证
function _enterpriseverify(){
	$u=new user;
	extract($u->info);
	if ($userid) {
		if (METHOD=='POST') {//提交状态的时候进行判断
			$enterprisename=kc_post('enterprisename');
			if(empty($enterprisename)) kc_ajax(array('JS'=>'alert(\'企业名称不能为空!\')'));
			$license_numbers=kc_post('license_numbers');
			if(empty($license_numbers)) kc_ajax(array('JS'=>'alert(\'营业执照注册号不能为空!\')'));
			$license_endtime=kc_post('license_endtime');
			if(empty($license_endtime)) kc_ajax(array('JS'=>'alert(\'营业执照到期时间不能为空!\')'));
			$licence_image=kc_post('licence_image');
			if(empty($licence_image)) kc_ajax(array('JS'=>'alert(\'营业执照不能为空!\')'));
			$db=new db;
			$rs=$db->getRows_one('%s_user_security','userid','userid='.$userid);
			if (empty($rs)) {
				$array=array(
					'userid'=>$userid,
					'enterprisename'=>$enterprisename,
					'license_numbers'=>$license_numbers,
					'license_endtime'=>$license_endtime,
					'licence_image'=>$licence_image,
					'enterpriseverify'=>1
				);
				$db->insert('%s_user_security',$array);
			} else {
				$db->update('%s_user_security',array('enterprisename'=>$enterprisename,'license_numbers'=>$license_numbers,'license_endtime'=>$license_endtime,'licence_image'=>$licence_image,'enterpriseverify'=>1),'userid='.$userid);
			}
			kc_tip('成功提交您的企业认证，请等待管理员审核!','ok', array('返回帐户中心'=>'/?user-security'));
		}
	}else{
		kc_tip('请先登录，或注册成为会员！','form');
	}
}
//帐户安全-管理员审核
function _security_edit(){
	$u=new user;
	$u->auth_role('admin');
	$userid=kc_post('userid',2,1);
	$db=new db;
	if ($userid) {
		if (METHOD=='POST') {//提交状态的时候进行判断
			$op=kc_post('op',2,1);
			$type=kc_post('type',array('e','p'),1);
			$reason=kc_post('reason');
			if(($op==0) && empty($reason)) kc_tip('请填写拒绝的原因！','form');
			$str=new str;
			if($str->len($reason)>100) kc_tip('拒绝的原因不能超过100字!');
			$db=new db;
			$rs=$db->getRows_one('%s_user_security','userid','userid='.$userid);
			if(empty($rs)) kc_tip('会员的帐户信息不存在！','form');
			if($op==0){
				$pm=array(
					'userid'=>$rs['userid'],
					'puserid'=>$u->info['userid'],
					'title'=>($type=='e') ? '您的企业认证不通过' : '您的个人实名认证不通过',
					'content'=>$reason,
					'date'=>time(),
				);
				$db->insert('%s_user_pm',$pm);
			}
			if($type=='e'){
				$array['enterpriseverify']=($op==1) ? 2 : 3;
			}else{
				$array['personverify']=($op==1) ? 2 : 3;
			}
			$db->update('%s_user_security',$array,'userid='.$userid);
			kc_tip('成功提交!','ok', array('返回会员认证'=>'/?_=user_security'));
		}
	}else{
		kc_tip('请先选择会员，再提交操作！','form');
	}
}
//上传ICO图标
function _makeico(){
	$id=kc_get('id',0,1);
	$s='<!DOCTYPE html>
	<html lang="zh-cn">
	<head>
		<meta charset="utf-8">
		<title>上传图标</title>
		<script type="text/javascript" charset="UTF-8" src="'.DIR.'user/js/jquery.js"></script>
		<script type="text/javascript" charset="UTF-8" src="'.DIR.'user/js/system.js"></script>
		<script type="text/javascript" charset="UTF-8" src="'.DIR.'user/js/ajaxupload.js"></script>
		<!--[if lt IE 9]>
		<script charset="UTF-8" src="'.DIR.'user/js/html5.js"></script>
		<![endif]-->
		<style type="text/css">body{padding:0;margin:0;}input{width:100px;height:30px;padding:0;margin:0;font-size:100px;cursor:pointer;}</style>
	</head>
	<body>
		<input id="up_menu" value="上传图标" type="submit" onclick="return false;"/>
		<script type="text/javascript">$.kc_upload(\'up_menu\',\''.$id.'\',\''.DIR.'user/manage.php?CMD=uploadico\',\''.SERV.'?_=website\');</script>
	</body>
	</html>
	';
	exit($s);
}
//处理ICO图标
function _uploadico(){
	$path='favicon.ico';
	$upload_error = "";
	$msg = "''";
	$inputname='filedata';//表单文件域name
	//判断是否有图片上传，如果有图片上传，则对图片进行裁减处理
	if (isset($_FILES[$inputname])) {
		$upfile=$_FILES[$inputname];
		if($upfile['error']==4){
			$upload_error='请选择要上传的文件';
		}else{
			//有文件上传的时候判断并提示
			if($upfile['size']>2097152){
				$upload_error='上传文件大小要小于2Mb，上传失败！'.$upfile['size'];
			}			
			$filename=$upfile['name'];//文件名
			$fext=strtolower(substr(strrchr($filename,'.'),1));
			//判断文件扩展名是否符合要求
			if($fext !='ico'){
				$upload_error='ICO图标类型只能是ico后缀！';
			}
		}
		//没有错误的时候进行保存操作
		if (empty($upload_error)) {
			$file=new file;
			$file->md(dirname($path));
			//保存图片
			move_uploaded_file($upfile['tmp_name'], ROOT.$path);
			$msg="{'url':'!".FULLURL."?{$id}.jpg','localname':'','id':'{$id}'}";
		}
	}
	echo "{'err':'".jsonString($upload_error)."','msg':".$msg."}";
	exit();
}
//升级会员组
function _updateug(){
	$u=new user;
	if(!$u->info['islogin']) kc_tip('请先登录!');
	$userid=$u->info['userid'];
	$gid=kc_post('gid',2,1);
	$db=new db;
	$rs=$db->getRows_one('%s_user_group','cost','gid='.$gid);
	if(empty($rs)) kc_tip('该会员组不存在!');
	$ugb=$db->getRows_one('%s_user_group_bind','gid','userid='.$userid);
	$tug=$db->getRows_one('%s_user_group','gid','','gid desc');
	if($ugb['gid']==$tug['gid']) kc_tip('您的会员组已是最高级别!');
	if($ugb['gid']>=$gid) kc_tip('您只能选择更高级的会员组!');
	$yue=get_user_yue($userid);
	if($yue < $rs['cost']) kc_tip('您的余额不足，请先充值!');
	log_account_change($userid, -$rs['cost'], 0, '升级会员组扣除余额'.$rs['cost'].'元', ACT_OTHER);
	$db->update('%s_user_group_bind',array('gid'=>$gid),'userid='.$userid);
	kc_tip('成功升级会员组!','ok');
}
?>