<?php
require '../global.php';

//管理员删除
function _delete(){
	$u=new user;
	$u->auth_role('user_point_delete');
	$pointid=kc_post('pointid',2,1);
	$db=new db;
	$db->delete('%s_point','pointid='.$pointid);
	$db->delete('%s_point_value','pointid='.$pointid);
	$db->delete('%s_user_point','pointid='.$pointid);
	kc_tip('?_=user_point','go');
}
//管理员编辑
function _edit(){
	$u=new user;
	$u->auth_role('user_point_edit');
	$pointid=kc_post('pointid',2,0);	
	if(empty($_POST['pointname'])) kc_tip('积分名称不能为空!','form');
	$db=new db;
	$pointname=$db->encode($_POST['pointname']);
	if($db->getRows_one('%s_point','pointid',"pointname='$pointname'".(empty($pointid)?'':' and pointid<>'.$pointid))) kc_tip('当前积分名已经存在!','form');
	$array=array(
		'pointname'=>$_POST['pointname'],
		'notes'=>$_POST['notes'],
	);
	if(empty($pointid)){
		$db->insert('%s_point',$array);
	}else{
		$db->update('%s_point',$array,'pointid='.$pointid);
	}
	kc_tip('?_=user_point','go');
}
//排序
function _order(){
	$u=new user;
	$u->auth_role('user_point_edit');
	$pointid=kc_post('pointid',2,1);
	if(!kc_validate($_POST['val'],2)) kc_tip('提交值必须为数字!','form');
	if(strlen($_POST['val'])>10) kc_tip('提交值不能超过十位数!','form');
	$db=new db;
	$db->update('%s_point',array('norder'=>$_POST['val']),'pointid='.$pointid);
	kc_ajax(array('JS'=>"\$.kc_close();"));
}
//设置积分操作值
function _point_set(){
	$u=new user;
	$u->auth_role('user_point_set');
	$pointid=kc_post('pointid',2,1);
	$app=kc_post('app',4,1);
	$code=kc_post('code',4,1);
	$val=kc_post('val',22,1);
	if($val>=100) kc_tip('操作值不能大于99!','form');	
	$db=new db;
	if($val==0){
		$db->delete('%s_point_value',"app='$app' and code='$code' and pointid='$pointid'");
	}else{
		$array=array(
			'app'=>$app,
			'code'=>$code,
			'pointid'=>$pointid,
			'value'=>$val,
		);
		$db->insert('%s_point_value',$array,false,'value='.$val);
	}
	if(kc_validate($val,2) && !empty($val)) $val='+'.$val;
	kc_ajax(array('JS'=>"\$.kc_close();\$('#point_{$code}_{$pointid}').val('$val');"));
}
//加减会员积分
function _addsubtract(){
	$u=new user;
	$u->auth_role('user_point_edit');
	$pointid=kc_post('pointid',2,1);
	$val=kc_post('val',22,1);
	if($val>999 && !$u->auth_role('admin',true)) kc_tip('数据超过1000的时候，只有总管才可以操作！');
	if($val>999999) kc_tip('操作值不能大于999999!','form');	
	$db=new db;
	if(empty($_POST['username'])) kc_tip('请填写会员名!','form');
	$username=$db->encode(trim($_POST['username']));
	$rs=$db->getRows_one('%s_user','userid',"username='$username'");	
	if(empty($rs)){
		kc_tip('您要操作的会员不存在!','form');
	}else{
		$u->setPoint_one($rs['userid'],$pointid,$val,'user','#manage','管理操作','系统');		
		//写入管理操作日志
		$array=array(
			'userid'=>$u->info['userid'],
			'app'=>'user',
			'action'=>'USER_POINT',
			'cid'=>$rs['userid'],
			'notes'=>($val>0 ? '+'.preg_replace('/^\+?/','',$val) : $val),
		);
		kc_log($array);
		kc_tip('操作成功!','ok','refresh');
	}
}
//编辑兑换
function _edit_exchange(){
	$u=new user;
	$u->auth_role('user_point_edit');
	$pointid=kc_post('pointid',2,1);
	$value=kc_post('value',2,1);
	$newpointid=kc_post('newpointid',2,1);
	$newvalue=kc_post('newvalue',2,1);
	$id=kc_post('id',2);
	$notes=kc_post('notes');		
	if($pointid==$newpointid) kc_tip('兑换类型不能一样!','form');
	if($value>99999 || $newvalue>99999) kc_tip('兑换值不能大于99999','form');
	if(empty($value) || empty($newvalue)) kc_tip('兑换值不能为0!','form');	
	$db=new db;
	$rs=$db->getRows_one('%s_user_point_exchange','id','pointid='.$pointid.' and newpointid='.$newpointid.(empty($id)?'':' and id<>'.$id));
	if(!empty($rs)) kc_tip('已经存在此类积分兑换规则，请不要重复','form');	
	$str=new str;
	if($str->len($notes)>200) kc_tip('备注内容过多!','form');	
	$array=array(
		'pointid'=>$pointid,
		'newpointid'=>$newpointid,
		'value'=>$value,
		'newvalue'=>$newvalue,
		'notes'=>$notes
	);
	if(empty($id)){
		$db->insert('%s_user_point_exchange',$array);
	}else{
		$db->update('%s_user_point_exchange',$array,'id='.$id);
	}
	kc_tip('?_=user_point_exchange','go');
}
//删除积分兑换规则
function _delete_exchange(){
	$u=new user;
	$u->auth_role('user_point_edit');
	$id=kc_post('id',3,1);
	$db=new db;
	$db->delete('%s_user_point_exchange',"id in($id)");	
	kc_tip('?_=user_point_exchange','go');
}
//管理员删除积分兑换记录
function _delete_point(){
	$u=new user;
	$u->auth_role('user_point_delete');
	$id=kc_post('id',3,1);
	$db=new db;
	$db->delete('%s_user_point_log',"id in($id)");
	kc_tip('?_=user_point_log','go');
}
//会员删除积分兑换记录
function _user_delete_point(){
	$u=new user;
	$u->auth_group('user_point_delete');
	$id=kc_post('id',3,1);
	$db=new db;
	$db->delete('%s_user_point_log',"id in($id)");
	kc_ajax(array('JS'=>"\$('.tr{$id}').remove();\$.kc_close();"));
}
//会员兑换积分
function _exchange(){
	$u=new user;
	$u->auth_group('user_point_exchange');
	$id=kc_post('id',2,1);
	$db=new db;
	$rs=$db->getRows_one('%s_user_point_exchange','id,pointid,value,newpointid,newvalue,notes','id='.$id);
	if(empty($rs)) kc_tip('该兑换比例已被删除！','form');
	$point=$db->getRows_two('%s_point','pointid','pointname');
	$userpoint=$u->getPoint($u->id);	
	if(METHOD=='POST'){
		if(empty($_POST['num'])) kc_tip('请填写消费'.$point[$rs['pointid']],'form');
		if(!kc_validate($_POST['num'],2)) kc_tip('消费金币必须为数字','form');
		$num=$_POST['num'];//会员提交的数据		
		if($userpoint[$rs['pointid']]['value']<$num){
			$fixnum=floor($userpoint[$rs['pointid']]['value']/$rs['value'])*$rs['value'];
			kc_tip('您填写的消费'.$point[$rs['pointid']].'超过了您所拥有的！','form',"\$('#pointnumber').val('$fixnum');");
		}elseif($num % $rs['value']!=0){
			$fixnum=round($num/$rs['value'])*$rs['value'];
			kc_tip('数值必须为'.$rs['value'].'的整数倍','form',"\$('#pointnumber').val('$fixnum');");
		}
		$u->setPoint_one($u->id,$rs['pointid'],'-'.$num,'user','#exchange','积分兑换','系统');
		$u->setPoint_one($u->id,$rs['newpointid'],($rs['newvalue']*$num/$rs['value']),'user','#exchange','积分兑换','系统');		
		if(!empty($_POST['MOBILE'])){
			kc_ajax(array('JS'=>'alert(\'成功兑换'.$num.'个'.$point[$rs['pointid']].'为'.($rs['newvalue']*$num/$rs['value']).'个'.$point[$rs['newpointid']].'!\');go(\'?m-user-info\');'));
		}else{
			kc_tip('成功兑换'.$num.'个'.$point[$rs['pointid']].'为'.($rs['newvalue']*$num/$rs['value']).'个'.$point[$rs['newpointid']].'!','ok','refresh');
		}
	}	
	$s='<table>';
	$s.='<tr><th>兑换比例：</th><td><em class="kc_ajaxlabel">'.$point[$rs['pointid']].' &nbsp; :  &nbsp; '.$point[$rs['newpointid']].' &nbsp; = &nbsp; '.$rs['value'].' &nbsp; : &nbsp; '.$rs['newvalue'].'</em></td></tr>';
	$s.='<tr><th>我的'.$point[$rs['pointid']].'：</th><td><em class="kc_ajaxlink">'.number_format($userpoint[$rs['pointid']]['value'],0).'</em></td></tr>';
	$s.='<tr><th>消费'.$point[$rs['pointid']].'：</th><td><input onchange="newpoint('.$rs['value'].','.$rs['newvalue'].')" type="text" name="num" id="pointnumber" class="kc_ajaxinput kc_ajaxwidth40"/><label class="kc_ajaxlabel">个，填写的数值必须得是'.$rs['value'].'的整数倍</label"></td></tr>';
	$s.='<tr><th>兑换'.$point[$rs['newpointid']].'：</th><td><input type="text" id="newpointvalue" class="kc_ajaxinput kc_ajaxwidth40" disabled="true"/></td></tr>';
	$s.='</table>';	
	kc_ajax(array(
	'TITLE'=>'积分兑换',
	'MAIN'=>$s,
	'ID'=>'kc_ajax',
	'WIDTH'=>390,
	'HEIGHT'=>285,
	'BUTTON'=>'<button onclick="$.kc_ajax({URL:\''.FULLURL.'user/manage_point.php\',CMD:\'exchange\',FORM:\'kc_ajaxform\',METHOD:\'POST\',id:\''.$id.'\'})">提交</button>',
	));
}
?>